/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.29.2(df04357573e045be658960bd50ff0a45d6d1eadb)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var z=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],V=function(I){for(var t=[],E=0,M=I.length;E<M;E++)t[E]=z[I[E]];return t},he=this,de=typeof global=="object"?global:{},X;(function(I){I.global=he;var t=function(){function E(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(E.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),E.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=E._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof I.global.importScripts=="function")},E._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},E}();I.Environment=t})(X||(X={}));var X;(function(I){var t=function(){function p(s,d,a){this.type=s,this.detail=d,this.timestamp=a}return p}();I.LoaderEvent=t;var E=function(){function p(s){this._events=[new t(1,"",s)]}return p.prototype.record=function(s,d){this._events.push(new t(s,d,I.Utilities.getHighPerformanceTimestamp()))},p.prototype.getEvents=function(){return this._events},p}();I.LoaderEventRecorder=E;var M=function(){function p(){}return p.prototype.record=function(s,d){},p.prototype.getEvents=function(){return[]},p.INSTANCE=new p,p}();I.NullLoaderEventRecorder=M})(X||(X={}));var X;(function(I){var t=function(){function E(){}return E.fileUriToFilePath=function(M,p){if(p=decodeURI(p).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(p))return p.substr(8);if(/^file:\/\//.test(p))return p.substr(5)}else if(/^file:\/\//.test(p))return p.substr(7);return p},E.startsWith=function(M,p){return M.length>=p.length&&M.substr(0,p.length)===p},E.endsWith=function(M,p){return M.length>=p.length&&M.substr(M.length-p.length)===p},E.containsQueryString=function(M){return/^[^\#]*\?/gi.test(M)},E.isAbsolutePath=function(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)},E.forEachProperty=function(M,p){if(M){var s=void 0;for(s in M)M.hasOwnProperty(s)&&p(s,M[s])}},E.isEmpty=function(M){var p=!0;return E.forEachProperty(M,function(){p=!1}),p},E.recursiveClone=function(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;var p=Array.isArray(M)?[]:{};return E.forEachProperty(M,function(s,d){d&&typeof d=="object"?p[s]=E.recursiveClone(d):p[s]=d}),p},E.generateAnonymousModule=function(){return"===anonymous"+E.NEXT_ANONYMOUS_ID+++"==="},E.isAnonymousModule=function(M){return E.startsWith(M,"===anonymous")},E.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=I.global.performance&&typeof I.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?I.global.performance.now():Date.now()},E.NEXT_ANONYMOUS_ID=1,E.PERFORMANCE_NOW_PROBED=!1,E.HAS_PERFORMANCE_NOW=!1,E}();I.Utilities=t})(X||(X={}));var X;(function(I){function t(p){if(p instanceof Error)return p;var s=new Error(p.message||String(p)||"Unknown Error");return p.stack&&(s.stack=p.stack),s}I.ensureError=t;var E=function(){function p(){}return p.validateConfigurationOptions=function(s){function d(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory method of "'+o.moduleId+'" has thrown an exception'),console.error(o);return}}if(s=s||{},typeof s.baseUrl!="string"&&(s.baseUrl=""),typeof s.isBuild!="boolean"&&(s.isBuild=!1),typeof s.paths!="object"&&(s.paths={}),typeof s.config!="object"&&(s.config={}),typeof s.catchError=="undefined"&&(s.catchError=!1),typeof s.recordStats=="undefined"&&(s.recordStats=!1),typeof s.urlArgs!="string"&&(s.urlArgs=""),typeof s.onError!="function"&&(s.onError=d),Array.isArray(s.ignoreDuplicateModules)||(s.ignoreDuplicateModules=[]),s.baseUrl.length>0&&(I.Utilities.endsWith(s.baseUrl,"/")||(s.baseUrl+="/")),typeof s.cspNonce!="string"&&(s.cspNonce=""),typeof s.preferScriptTags=="undefined"&&(s.preferScriptTags=!1),Array.isArray(s.nodeModules)||(s.nodeModules=[]),s.nodeCachedData&&typeof s.nodeCachedData=="object"&&(typeof s.nodeCachedData.seed!="string"&&(s.nodeCachedData.seed="seed"),(typeof s.nodeCachedData.writeDelay!="number"||s.nodeCachedData.writeDelay<0)&&(s.nodeCachedData.writeDelay=1e3*7),!s.nodeCachedData.path||typeof s.nodeCachedData.path!="string")){var a=t(new Error("INVALID cached data configuration, 'path' MUST be set"));a.phase="configuration",s.onError(a),s.nodeCachedData=void 0}return s},p.mergeConfigurationOptions=function(s,d){s===void 0&&(s=null),d===void 0&&(d=null);var a=I.Utilities.recursiveClone(d||{});return I.Utilities.forEachProperty(s,function(o,f){o==="ignoreDuplicateModules"&&typeof a.ignoreDuplicateModules!="undefined"?a.ignoreDuplicateModules=a.ignoreDuplicateModules.concat(f):o==="paths"&&typeof a.paths!="undefined"?I.Utilities.forEachProperty(f,function(S,c){return a.paths[S]=c}):o==="config"&&typeof a.config!="undefined"?I.Utilities.forEachProperty(f,function(S,c){return a.config[S]=c}):a[o]=I.Utilities.recursiveClone(f)}),p.validateConfigurationOptions(a)},p}();I.ConfigurationOptionsUtil=E;var M=function(){function p(s,d){if(this._env=s,this.options=E.mergeConfigurationOptions(d),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var a=this.options.nodeRequire.main.filename,o=Math.max(a.lastIndexOf("/"),a.lastIndexOf("\\"));this.options.baseUrl=a.substring(0,o+1)}if(this.options.nodeMain&&this._env.isNode){var a=this.options.nodeMain,o=Math.max(a.lastIndexOf("/"),a.lastIndexOf("\\"));this.options.baseUrl=a.substring(0,o+1)}}}return p.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var s=0;s<this.options.ignoreDuplicateModules.length;s++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[s]]=!0},p.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var s=0,d=this.options.nodeModules;s<d.length;s++){var a=d[s];this.nodeModulesMap[a]=!0}},p.prototype._createSortedPathsRules=function(){var s=this;this.sortedPathsRules=[],I.Utilities.forEachProperty(this.options.paths,function(d,a){Array.isArray(a)?s.sortedPathsRules.push({from:d,to:a}):s.sortedPathsRules.push({from:d,to:[a]})}),this.sortedPathsRules.sort(function(d,a){return a.from.length-d.from.length})},p.prototype.cloneAndMerge=function(s){return new p(this._env,E.mergeConfigurationOptions(s,this.options))},p.prototype.getOptionsLiteral=function(){return this.options},p.prototype._applyPaths=function(s){for(var d,a=0,o=this.sortedPathsRules.length;a<o;a++)if(d=this.sortedPathsRules[a],I.Utilities.startsWith(s,d.from)){for(var f=[],S=0,c=d.to.length;S<c;S++)f.push(d.to[S]+s.substr(d.from.length));return f}return[s]},p.prototype._addUrlArgsToUrl=function(s){return I.Utilities.containsQueryString(s)?s+"&"+this.options.urlArgs:s+"?"+this.options.urlArgs},p.prototype._addUrlArgsIfNecessaryToUrl=function(s){return this.options.urlArgs?this._addUrlArgsToUrl(s):s},p.prototype._addUrlArgsIfNecessaryToUrls=function(s){if(this.options.urlArgs)for(var d=0,a=s.length;d<a;d++)s[d]=this._addUrlArgsToUrl(s[d]);return s},p.prototype.moduleIdToPaths=function(s){var d=this.nodeModulesMap[s]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(s);if(d)return this.isBuild()?["empty:"]:["node|"+s];var a=s,o;if(!I.Utilities.endsWith(a,".js")&&!I.Utilities.isAbsolutePath(a)){o=this._applyPaths(a);for(var f=0,S=o.length;f<S;f++)this.isBuild()&&o[f]==="empty:"||(I.Utilities.isAbsolutePath(o[f])||(o[f]=this.options.baseUrl+o[f]),!I.Utilities.endsWith(o[f],".js")&&!I.Utilities.containsQueryString(o[f])&&(o[f]=o[f]+".js"))}else!I.Utilities.endsWith(a,".js")&&!I.Utilities.containsQueryString(a)&&(a=a+".js"),o=[a];return this._addUrlArgsIfNecessaryToUrls(o)},p.prototype.requireToUrl=function(s){var d=s;return I.Utilities.isAbsolutePath(d)||(d=this._applyPaths(d)[0],I.Utilities.isAbsolutePath(d)||(d=this.options.baseUrl+d)),this._addUrlArgsIfNecessaryToUrl(d)},p.prototype.isBuild=function(){return this.options.isBuild},p.prototype.isDuplicateMessageIgnoredFor=function(s){return this.ignoreDuplicateModulesMap.hasOwnProperty(s)},p.prototype.getConfigForModule=function(s){if(this.options.config)return this.options.config[s]},p.prototype.shouldCatchError=function(){return this.options.catchError},p.prototype.shouldRecordStats=function(){return this.options.recordStats},p.prototype.onError=function(s){this.options.onError(s)},p}();I.Configuration=M})(X||(X={}));var X;(function(I){var t=function(){function o(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(f,S,c,h){var m=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){var v=f.getConfig().getOptionsLiteral().preferScriptTags;v?this._scriptLoader=new E:this._scriptLoader=new s(this._env)}else this._env.isNode?this._scriptLoader=new s(this._env):this._scriptLoader=new E;var i={callback:c,errorback:h};if(this._callbackMap.hasOwnProperty(S)){this._callbackMap[S].push(i);return}this._callbackMap[S]=[i],this._scriptLoader.load(f,S,function(){return m.triggerCallback(S)},function(u){return m.triggerErrorback(S,u)})},o.prototype.triggerCallback=function(f){var S=this._callbackMap[f];delete this._callbackMap[f];for(var c=0;c<S.length;c++)S[c].callback()},o.prototype.triggerErrorback=function(f,S){var c=this._callbackMap[f];delete this._callbackMap[f];for(var h=0;h<c.length;h++)c[h].errorback(S)},o}(),E=function(){function o(){}return o.prototype.attachListeners=function(f,S,c){var h=function(){f.removeEventListener("load",m),f.removeEventListener("error",v)},m=function(i){h(),S()},v=function(i){h(),c(i)};f.addEventListener("load",m),f.addEventListener("error",v)},o.prototype.load=function(f,S,c,h){if(/^node\|/.test(S)){var m=f.getConfig().getOptionsLiteral(),v=d(f.getRecorder(),m.nodeRequire||I.global.nodeRequire),i=S.split("|"),u=null;try{u=v(i[1])}catch(r){h(r);return}f.enqueueDefineAnonymousModule([],function(){return u}),c()}else{var _=document.createElement("script");_.setAttribute("async","async"),_.setAttribute("type","text/javascript"),this.attachListeners(_,c,h);var N=f.getConfig().getOptionsLiteral().trustedTypesPolicy;N&&(S=N.createScriptURL(S)),_.setAttribute("src",S);var n=f.getConfig().getOptionsLiteral().cspNonce;n&&_.setAttribute("nonce",n),document.getElementsByTagName("head")[0].appendChild(_)}},o}();function M(o){var f=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var S=f?self.eval(f.createScript("","true")):new Function("true");return S.call(self),!0}catch(c){return!1}}var p=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(f)),this._cachedCanUseEval},o.prototype.load=function(f,S,c,h){var m=f.getConfig().getOptionsLiteral().trustedTypesPolicy,v=/^((http:)|(https:)|(file:))/.test(S)&&S.substring(0,self.origin.length)!==self.origin;if(!v&&this._canUseEval(f)){fetch(S).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+S;var u=m?self.eval(m.createScript("",i)):new Function(i);u.call(self),c()}).then(void 0,h);return}try{m&&(S=m.createScriptURL(S)),importScripts(S),c()}catch(i){h(i)}},o}(),s=function(){function o(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},o.prototype._initNodeRequire=function(f,S){var c=S.getConfig().getOptionsLiteral().nodeCachedData;if(!c||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var h=this,m=f("module");function v(i){var u=i.constructor,_=function(n){try{return i.require(n)}finally{}};return _.resolve=function(n,r){return u._resolveFilename(n,i,!1,r)},_.resolve.paths=function(n){return u._resolveLookupPaths(n,i)},_.main=process.mainModule,_.extensions=u._extensions,_.cache=u._cache,_}m.prototype._compile=function(i,u){var _=m.wrap(i.replace(/^#!.*/,"")),N=S.getRecorder(),n=h._getCachedDataPath(c,u),r={filename:u},l;try{var g=h._fs.readFileSync(n);l=g.slice(0,16),r.cachedData=g.slice(16),N.record(60,n)}catch(U){N.record(61,n)}var C=new h._vm.Script(_,r),b=C.runInThisContext(r),L=h._path.dirname(u),w=v(this),y=[this.exports,w,this,u,L,process,de,Buffer],P=b.apply(this.exports,y);return h._handleCachedData(C,_,n,!r.cachedData,S),h._verifyCachedData(C,_,n,l,S),P}},o.prototype.load=function(f,S,c,h){var m=this,v=f.getConfig().getOptionsLiteral(),i=d(f.getRecorder(),v.nodeRequire||I.global.nodeRequire),u=v.nodeInstrumenter||function(b){return b};this._init(i),this._initNodeRequire(i,f);var _=f.getRecorder();if(/^node\|/.test(S)){var N=S.split("|"),n=null;try{n=i(N[1])}catch(b){h(b);return}f.enqueueDefineAnonymousModule([],function(){return n}),c()}else{S=I.Utilities.fileUriToFilePath(this._env.isWindows,S);var r=this._path.normalize(S),l=this._getElectronRendererScriptPathOrUri(r),g=Boolean(v.nodeCachedData),C=g?this._getCachedDataPath(v.nodeCachedData,S):void 0;this._readSourceAndCachedData(r,C,_,function(b,L,w,y){if(b){h(b);return}var P;L.charCodeAt(0)===o._BOM?P=o._PREFIX+L.substring(1)+o._SUFFIX:P=o._PREFIX+L+o._SUFFIX,P=u(P,r);var U={filename:l,cachedData:w},R=m._createAndEvalScript(f,P,U,c,h);m._handleCachedData(R,P,C,g&&!w,f),m._verifyCachedData(R,P,C,y,f)})}},o.prototype._createAndEvalScript=function(f,S,c,h,m){var v=f.getRecorder();v.record(31,c.filename);var i=new this._vm.Script(S,c),u=i.runInThisContext(c),_=f.getGlobalAMDDefineFunc(),N=!1,n=function(){return N=!0,_.apply(null,arguments)};return n.amd=_.amd,u.call(I.global,f.getGlobalAMDRequireFunc(),n,c.filename,this._path.dirname(c.filename)),v.record(32,c.filename),N?h():m(new Error("Didn't receive define call in "+c.filename+"!")),i},o.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var S=f.match(/^([a-z])\:(.*)/i);return S?"file:///"+(S[1].toUpperCase()+":"+S[2]).replace(/\\/g,"/"):"file://"+f},o.prototype._getCachedDataPath=function(f,S){var c=this._crypto.createHash("md5").update(S,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),h=this._path.basename(S).replace(/\.js$/,"");return this._path.join(f.path,h+"-"+c+".code")},o.prototype._handleCachedData=function(f,S,c,h,m){var v=this;f.cachedDataRejected?this._fs.unlink(c,function(i){m.getRecorder().record(62,c),v._createAndWriteCachedData(f,S,c,m),i&&m.getConfig().onError(i)}):h&&this._createAndWriteCachedData(f,S,c,m)},o.prototype._createAndWriteCachedData=function(f,S,c,h){var m=this,v=Math.ceil(h.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),i=-1,u=0,_=void 0,N=function(){setTimeout(function(){_||(_=m._crypto.createHash("md5").update(S,"utf8").digest());var n=f.createCachedData();if(!(n.length===0||n.length===i||u>=5)){if(n.length<i){N();return}i=n.length,m._fs.writeFile(c,Buffer.concat([_,n]),function(r){r&&h.getConfig().onError(r),h.getRecorder().record(63,c),N()})}},v*Math.pow(4,u++))};N()},o.prototype._readSourceAndCachedData=function(f,S,c,h){if(!S)this._fs.readFile(f,{encoding:"utf8"},h);else{var m=void 0,v=void 0,i=void 0,u=2,_=function(N){N?h(N):--u==0&&h(void 0,m,v,i)};this._fs.readFile(f,{encoding:"utf8"},function(N,n){m=n,_(N)}),this._fs.readFile(S,function(N,n){!N&&n&&n.length>0?(i=n.slice(0,16),v=n.slice(16),c.record(60,S)):c.record(61,S),_()})}},o.prototype._verifyCachedData=function(f,S,c,h,m){var v=this;!h||f.cachedDataRejected||setTimeout(function(){var i=v._crypto.createHash("md5").update(S,"utf8").digest();h.equals(i)||(m.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+c+"' now, but a RESTART IS REQUIRED")),v._fs.unlink(c,function(u){u&&m.getConfig().onError(u)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function d(o,f){if(f.__$__isRecorded)return f;var S=function(h){o.record(33,h);try{return f(h)}finally{o.record(34,h)}};return S.__$__isRecorded=!0,S}I.ensureRecordedNodeRequire=d;function a(o){return new t(o)}I.createScriptLoader=a})(X||(X={}));var X;(function(I){var t=function(){function a(o){var f=o.lastIndexOf("/");f!==-1?this.fromModulePath=o.substr(0,f+1):this.fromModulePath=""}return a._normalizeModuleId=function(o){var f=o,S;for(S=/\/\.\//;S.test(f);)f=f.replace(S,"/");for(f=f.replace(/^\.\//g,""),S=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;S.test(f);)f=f.replace(S,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},a.prototype.resolveModule=function(o){var f=o;return I.Utilities.isAbsolutePath(f)||(I.Utilities.startsWith(f,"./")||I.Utilities.startsWith(f,"../"))&&(f=a._normalizeModuleId(this.fromModulePath+f)),f},a.ROOT=new a(""),a}();I.ModuleIdResolver=t;var E=function(){function a(o,f,S,c,h,m){this.id=o,this.strId=f,this.dependencies=S,this._callback=c,this._errorback=h,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return a._safeInvokeFunction=function(o,f){try{return{returnedValue:o.apply(I.global,f),producedError:null}}catch(S){return{returnedValue:null,producedError:S}}},a._invokeFactory=function(o,f,S,c){return o.isBuild()&&!I.Utilities.isAnonymousModule(f)?{returnedValue:null,producedError:null}:o.shouldCatchError()?this._safeInvokeFunction(S,c):{returnedValue:S.apply(I.global,c),producedError:null}},a.prototype.complete=function(o,f,S){this._isComplete=!0;var c=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var h=a._invokeFactory(f,this.strId,this._callback,S);c=h.producedError,o.record(22,this.strId),!c&&typeof h.returnedValue!="undefined"&&(!this.exportsPassedIn||I.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(c){var m=I.ensureError(c);m.phase="factory",m.moduleId=this.strId,this.error=m,f.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},a.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},a.prototype.isComplete=function(){return this._isComplete},a}();I.Module=E;var M=function(){function a(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return a.prototype.getMaxModuleId=function(){return this._nextId},a.prototype.getModuleId=function(o){var f=this._strModuleIdToIntModuleId.get(o);return typeof f=="undefined"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(o,f),this._intModuleIdToStrModuleId[f]=o),f},a.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},a}(),p=function(){function a(o){this.id=o}return a.EXPORTS=new a(0),a.MODULE=new a(1),a.REQUIRE=new a(2),a}();I.RegularDependency=p;var s=function(){function a(o,f,S){this.id=o,this.pluginId=f,this.pluginParam=S}return a}();I.PluginDependency=s;var d=function(){function a(o,f,S,c,h){h===void 0&&(h=0),this._env=o,this._scriptLoader=f,this._loaderAvailableTimestamp=h,this._defineFunc=S,this._requireFunc=c,this._moduleIdProvider=new M,this._config=new I.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return a.prototype.reset=function(){return new a(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},a.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},a.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},a._findRelevantLocationInStack=function(o,f){for(var S=function(r){return r.replace(/\\/g,"/")},c=S(o),h=f.split(/\n/),m=0;m<h.length;m++){var v=h[m].match(/(.*):(\d+):(\d+)\)?$/);if(v){var i=v[1],u=v[2],_=v[3],N=Math.max(i.lastIndexOf(" ")+1,i.lastIndexOf("(")+1);if(i=i.substr(N),i=S(i),i===c){var n={line:parseInt(u,10),col:parseInt(_,10)};return n.line===1&&(n.col-="(function (require, define, __filename, __dirname) { ".length),n}}}throw new Error("Could not correlate define call site for needle "+o)},a.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],f=0,S=0,c=this._modules2.length;S<c;S++){var h=this._modules2[S];if(!!h){var m=this._buildInfoPath[h.id]||null,v=this._buildInfoDefineStack[h.id]||null,i=this._buildInfoDependencies[h.id];o[f++]={id:h.strId,path:m,defineLocation:m&&v?a._findRelevantLocationInStack(m,v):null,dependencies:i,shim:null,exports:h.exports}}}return o},a.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new I.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=I.NullLoaderEventRecorder.INSTANCE),this._recorder},a.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},a.prototype.enqueueDefineAnonymousModule=function(o,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var S=null;this._config.isBuild()&&(S=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:S,dependencies:o,callback:f}},a.prototype.defineModule=function(o,f,S,c,h,m){var v=this;m===void 0&&(m=new t(o));var i=this._moduleIdProvider.getModuleId(o);if(this._modules2[i]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var u=new E(i,o,this._normalizeDependencies(f,m),S,c,m);this._modules2[i]=u,this._config.isBuild()&&(this._buildInfoDefineStack[i]=h,this._buildInfoDependencies[i]=(u.dependencies||[]).map(function(_){return v._moduleIdProvider.getStrModuleId(_.id)})),this._resolve(u)},a.prototype._normalizeDependency=function(o,f){if(o==="exports")return p.EXPORTS;if(o==="module")return p.MODULE;if(o==="require")return p.REQUIRE;var S=o.indexOf("!");if(S>=0){var c=f.resolveModule(o.substr(0,S)),h=f.resolveModule(o.substr(S+1)),m=this._moduleIdProvider.getModuleId(c+"!"+h),v=this._moduleIdProvider.getModuleId(c);return new s(m,v,h)}return new p(this._moduleIdProvider.getModuleId(f.resolveModule(o)))},a.prototype._normalizeDependencies=function(o,f){for(var S=[],c=0,h=0,m=o.length;h<m;h++)S[c++]=this._normalizeDependency(o[h],f);return S},a.prototype._relativeRequire=function(o,f,S,c){if(typeof f=="string")return this.synchronousRequire(f,o);this.defineModule(I.Utilities.generateAnonymousModule(),f,S,c,null,o)},a.prototype.synchronousRequire=function(o,f){f===void 0&&(f=new t(o));var S=this._normalizeDependency(o,f),c=this._modules2[S.id];if(!c)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!c.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(c.error)throw c.error;return c.exports},a.prototype.configure=function(o,f){var S=this._config.shouldRecordStats();f?this._config=new I.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!S&&(this._recorder=null)},a.prototype.getConfig=function(){return this._config},a.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),f.dependencies,f.callback,null,f.stack)}},a.prototype._createLoadError=function(o,f){var S=this,c=this._moduleIdProvider.getStrModuleId(o),h=(this._inverseDependencies2[o]||[]).map(function(v){return S._moduleIdProvider.getStrModuleId(v)}),m=I.ensureError(f);return m.phase="loading",m.moduleId=c,m.neededBy=h,m},a.prototype._onLoadError=function(o,f){var S=this._createLoadError(o,f);this._modules2[o]||(this._modules2[o]=new E(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},function(){},null));for(var c=[],h=0,m=this._moduleIdProvider.getMaxModuleId();h<m;h++)c[h]=!1;var v=!1,i=[];for(i.push(o),c[o]=!0;i.length>0;){var u=i.shift(),_=this._modules2[u];_&&(v=_.onDependencyError(S)||v);var N=this._inverseDependencies2[u];if(N)for(var h=0,m=N.length;h<m;h++){var n=N[h];c[n]||(i.push(n),c[n]=!0)}}v||this._config.onError(S)},a.prototype._hasDependencyPath=function(o,f){var S=this._modules2[o];if(!S)return!1;for(var c=[],h=0,m=this._moduleIdProvider.getMaxModuleId();h<m;h++)c[h]=!1;var v=[];for(v.push(S),c[o]=!0;v.length>0;){var i=v.shift(),u=i.dependencies;if(u)for(var h=0,m=u.length;h<m;h++){var _=u[h];if(_.id===f)return!0;var N=this._modules2[_.id];N&&!c[_.id]&&(c[_.id]=!0,v.push(N))}}return!1},a.prototype._findCyclePath=function(o,f,S){if(o===f||S===50)return[o];var c=this._modules2[o];if(!c)return null;var h=c.dependencies;if(h)for(var m=0,v=h.length;m<v;m++){var i=this._findCyclePath(h[m].id,f,S+1);if(i!==null)return i.push(o),i}return null},a.prototype._createRequire=function(o){var f=this,S=function(c,h,m){return f._relativeRequire(o,c,h,m)};return S.toUrl=function(c){return f._config.requireToUrl(o.resolveModule(c))},S.getStats=function(){return f.getLoaderEvents()},S.hasDependencyCycle=function(){return f._hasDependencyCycle},S.config=function(c,h){h===void 0&&(h=!1),f.configure(c,h)},S.__$__nodeRequire=I.global.nodeRequire,S},a.prototype._loadModule=function(o){var f=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var S=this._moduleIdProvider.getStrModuleId(o),c=this._config.moduleIdToPaths(S),h=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(S.indexOf("/")===-1||h.test(S))&&c.push("node|"+S);var m=-1,v=function(i){if(m++,m>=c.length)f._onLoadError(o,i);else{var u=c[m],_=f.getRecorder();if(f._config.isBuild()&&u==="empty:"){f._buildInfoPath[o]=u,f.defineModule(f._moduleIdProvider.getStrModuleId(o),[],null,null,null),f._onLoad(o);return}_.record(10,u),f._scriptLoader.load(f,u,function(){f._config.isBuild()&&(f._buildInfoPath[o]=u),_.record(11,u),f._onLoad(o)},function(N){_.record(12,u),v(N)})}};v(null)}},a.prototype._loadPluginDependency=function(o,f){var S=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var c=function(h){S.defineModule(S._moduleIdProvider.getStrModuleId(f.id),[],h,null,null)};c.error=function(h){S._config.onError(S._createLoadError(f.id,h))},o.load(f.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}},a.prototype._resolve=function(o){var f=this,S=o.dependencies;if(S)for(var c=0,h=S.length;c<h;c++){var m=S[c];if(m===p.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(m===p.MODULE){o.unresolvedDependenciesCount--;continue}if(m===p.REQUIRE){o.unresolvedDependenciesCount--;continue}var v=this._modules2[m.id];if(v&&v.isComplete()){if(v.error){o.onDependencyError(v.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var i=this._findCyclePath(m.id,o.id,0)||[];i.reverse(),i.push(m.id),console.warn(i.map(function(N){return f._moduleIdProvider.getStrModuleId(N)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(o.id),m instanceof s){var u=this._modules2[m.pluginId];if(u&&u.isComplete()){this._loadPluginDependency(u.exports,m);continue}var _=this._inversePluginDependencies2.get(m.pluginId);_||(_=[],this._inversePluginDependencies2.set(m.pluginId,_)),_.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},a.prototype._onModuleComplete=function(o){var f=this,S=this.getRecorder();if(!o.isComplete()){var c=o.dependencies,h=[];if(c)for(var m=0,v=c.length;m<v;m++){var i=c[m];if(i===p.EXPORTS){h[m]=o.exports;continue}if(i===p.MODULE){h[m]={id:o.strId,config:function(){return f._config.getConfigForModule(o.strId)}};continue}if(i===p.REQUIRE){h[m]=this._createRequire(o.moduleIdResolver);continue}var u=this._modules2[i.id];if(u){h[m]=u.exports;continue}h[m]=null}o.complete(S,this._config,h);var _=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,_)for(var m=0,v=_.length;m<v;m++){var N=_[m],n=this._modules2[N];n.unresolvedDependenciesCount--,n.unresolvedDependenciesCount===0&&this._onModuleComplete(n)}var r=this._inversePluginDependencies2.get(o.id);if(r){this._inversePluginDependencies2.delete(o.id);for(var m=0,v=r.length;m<v;m++)this._loadPluginDependency(o.exports,r[m])}}},a}();I.ModuleManager=d})(X||(X={}));var $,X;(function(I){var t=new I.Environment,E=null,M=function(a,o,f){typeof a!="string"&&(f=o,o=a,a=null),(typeof o!="object"||!Array.isArray(o))&&(f=o,o=null),o||(o=["require","exports","module"]),a?E.defineModule(a,o,f,null,null):E.enqueueDefineAnonymousModule(o,f)};M.amd={jQuery:!0};var p=function(a,o){o===void 0&&(o=!1),E.configure(a,o)},s=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){p(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(I.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};s.config=p,s.getConfig=function(){return E.getConfig().getOptionsLiteral()},s.reset=function(){E=E.reset()},s.getBuildInfo=function(){return E.getBuildInfo()},s.getStats=function(){return E.getLoaderEvents()},s.define=function(){return M.apply(null,arguments)};function d(){if(typeof I.global.require!="undefined"||typeof require!="undefined"){var a=I.global.require||require;if(typeof a=="function"&&typeof a.resolve=="function"){var o=I.ensureRecordedNodeRequire(E.getRecorder(),a);I.global.nodeRequire=o,s.nodeRequire=o,s.__$__nodeRequire=o}}t.isNode&&!t.isElectronRenderer?(module.exports=s,require=s):(t.isElectronRenderer||(I.global.define=M),I.global.require=s)}I.init=d,(typeof I.global.define!="function"||!I.global.define.amd)&&(E=new I.ModuleManager(t,I.createScriptLoader(t),M,s,I.Utilities.getHighPerformanceTimestamp()),typeof I.global.require!="undefined"&&typeof I.global.require!="function"&&s.config(I.global.require),$=function(){return M.apply(null,arguments)},$.amd=M.amd,typeof doNotInitLoader=="undefined"&&d())})(X||(X={})),$(z[14],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(p,s,d,a){this.originalStart=p,this.originalLength=s,this.modifiedStart=d,this.modifiedLength=a}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),$(z[4],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NotSupportedError=t.illegalState=t.illegalArgument=t.canceled=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(m){setTimeout(()=>{throw m.stack?new Error(m.message+`

`+m.stack):m},0)}}emit(m){this.listeners.forEach(v=>{v(m)})}onUnexpectedError(m){this.unexpectedErrorHandler(m),this.emit(m)}onUnexpectedExternalError(m){this.unexpectedErrorHandler(m)}}t.ErrorHandler=E,t.errorHandler=new E;function M(h){a(h)||t.errorHandler.onUnexpectedError(h)}t.onUnexpectedError=M;function p(h){a(h)||t.errorHandler.onUnexpectedExternalError(h)}t.onUnexpectedExternalError=p;function s(h){if(h instanceof Error){let{name:m,message:v}=h;const i=h.stacktrace||h.stack;return{$isError:!0,name:m,message:v,stack:i}}return h}t.transformErrorForSerialization=s;const d="Canceled";function a(h){return h instanceof Error&&h.name===d&&h.message===d}t.isPromiseCanceledError=a;function o(){const h=new Error(d);return h.name=h.message,h}t.canceled=o;function f(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}t.illegalArgument=f;function S(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}t.illegalState=S;class c extends Error{constructor(m){super("NotSupported");m&&(this.message=m)}}t.NotSupportedError=c}),$(z[15],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(M){const p=this;let s=!1,d;return function(){return s||(s=!0,d=M.apply(p,arguments)),d}}t.once=E}),$(z[16],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(M){function p(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}M.is=p;const s=Object.freeze([]);function d(){return s}M.empty=d;function*a(l){yield l}M.single=a;function o(l){return l||s}M.from=o;function f(l){return!l||l[Symbol.iterator]().next().done===!0}M.isEmpty=f;function S(l){return l[Symbol.iterator]().next().value}M.first=S;function c(l,g){for(const C of l)if(g(C))return!0;return!1}M.some=c;function h(l,g){for(const C of l)if(g(C))return C}M.find=h;function*m(l,g){for(const C of l)g(C)&&(yield C)}M.filter=m;function*v(l,g){let C=0;for(const b of l)yield g(b,C++)}M.map=v;function*i(...l){for(const g of l)for(const C of g)yield C}M.concat=i;function*u(l){for(const g of l)for(const C of g)yield C}M.concatNested=u;function _(l,g,C){let b=C;for(const L of l)b=g(b,L);return b}M.reduce=_;function*N(l,g,C=l.length){for(g<0&&(g+=l.length),C<0?C+=l.length:C>l.length&&(C=l.length);g<C;g++)yield l[g]}M.slice=N;function n(l,g=Number.POSITIVE_INFINITY){const C=[];if(g===0)return[C,l];const b=l[Symbol.iterator]();for(let L=0;L<g;L++){const w=b.next();if(w.done)return[C,M.empty()];C.push(w.value)}return[C,{[Symbol.iterator](){return b}}]}M.consume=n;function r(l,g,C=(b,L)=>b===L){const b=l[Symbol.iterator](),L=g[Symbol.iterator]();for(;;){const w=b.next(),y=L.next();if(w.done!==y.done)return!1;if(w.done)return!0;if(!C(w.value,y.value))return!1}}M.equals=r})(E=t.Iterable||(t.Iterable={}))}),$(z[17],V([0,1,4]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyCodeUtils=void 0;class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,_){this._keyCodeToStr[u]=_,this._strToKeyCode[_.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const p=new M,s=new M,d=new M;(function(){function i(u,_,N=_,n=N){p.define(u,_),s.define(u,N),d.define(u,n)}i(0,"unknown"),i(1,"Backspace"),i(2,"Tab"),i(3,"Enter"),i(4,"Shift"),i(5,"Ctrl"),i(6,"Alt"),i(7,"PauseBreak"),i(8,"CapsLock"),i(9,"Escape"),i(10,"Space"),i(11,"PageUp"),i(12,"PageDown"),i(13,"End"),i(14,"Home"),i(15,"LeftArrow","Left"),i(16,"UpArrow","Up"),i(17,"RightArrow","Right"),i(18,"DownArrow","Down"),i(19,"Insert"),i(20,"Delete"),i(21,"0"),i(22,"1"),i(23,"2"),i(24,"3"),i(25,"4"),i(26,"5"),i(27,"6"),i(28,"7"),i(29,"8"),i(30,"9"),i(31,"A"),i(32,"B"),i(33,"C"),i(34,"D"),i(35,"E"),i(36,"F"),i(37,"G"),i(38,"H"),i(39,"I"),i(40,"J"),i(41,"K"),i(42,"L"),i(43,"M"),i(44,"N"),i(45,"O"),i(46,"P"),i(47,"Q"),i(48,"R"),i(49,"S"),i(50,"T"),i(51,"U"),i(52,"V"),i(53,"W"),i(54,"X"),i(55,"Y"),i(56,"Z"),i(57,"Meta"),i(58,"ContextMenu"),i(59,"F1"),i(60,"F2"),i(61,"F3"),i(62,"F4"),i(63,"F5"),i(64,"F6"),i(65,"F7"),i(66,"F8"),i(67,"F9"),i(68,"F10"),i(69,"F11"),i(70,"F12"),i(71,"F13"),i(72,"F14"),i(73,"F15"),i(74,"F16"),i(75,"F17"),i(76,"F18"),i(77,"F19"),i(78,"NumLock"),i(79,"ScrollLock"),i(80,";",";","OEM_1"),i(81,"=","=","OEM_PLUS"),i(82,",",",","OEM_COMMA"),i(83,"-","-","OEM_MINUS"),i(84,".",".","OEM_PERIOD"),i(85,"/","/","OEM_2"),i(86,"`","`","OEM_3"),i(110,"ABNT_C1"),i(111,"ABNT_C2"),i(87,"[","[","OEM_4"),i(88,"\\","\\","OEM_5"),i(89,"]","]","OEM_6"),i(90,"'","'","OEM_7"),i(91,"OEM_8"),i(92,"OEM_102"),i(93,"NumPad0"),i(94,"NumPad1"),i(95,"NumPad2"),i(96,"NumPad3"),i(97,"NumPad4"),i(98,"NumPad5"),i(99,"NumPad6"),i(100,"NumPad7"),i(101,"NumPad8"),i(102,"NumPad9"),i(103,"NumPad_Multiply"),i(104,"NumPad_Add"),i(105,"NumPad_Separator"),i(106,"NumPad_Subtract"),i(107,"NumPad_Decimal"),i(108,"NumPad_Divide")})();var a;(function(i){function u(l){return p.keyCodeToStr(l)}i.toString=u;function _(l){return p.strToKeyCode(l)}i.fromString=_;function N(l){return s.keyCodeToStr(l)}i.toUserSettingsUS=N;function n(l){return d.keyCodeToStr(l)}i.toUserSettingsGeneral=n;function r(l){return s.strToKeyCode(l)||d.strToKeyCode(l)}i.fromUserSettings=r})(a=t.KeyCodeUtils||(t.KeyCodeUtils={}));function o(i,u){const _=(u&65535)<<16>>>0;return(i|_)>>>0}t.KeyChord=o;function f(i,u){if(i===0)return null;const _=(i&65535)>>>0,N=(i&4294901760)>>>16;return N!==0?new h([S(_,u),S(N,u)]):new h([S(_,u)])}t.createKeybinding=f;function S(i,u){const _=!!(i&2048),N=!!(i&256),n=u===2?N:_,r=!!(i&1024),l=!!(i&512),g=u===2?_:N,C=i&255;return new c(n,r,l,g,C)}t.createSimpleKeybinding=S;class c{constructor(u,_,N,n,r){this.ctrlKey=u,this.shiftKey=_,this.altKey=N,this.metaKey=n,this.keyCode=r}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new h([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=c;class h{constructor(u){if(u.length===0)throw(0,E.illegalArgument)("parts");this.parts=u}}t.ChordKeybinding=h;class m{constructor(u,_,N,n,r,l){this.ctrlKey=u,this.shiftKey=_,this.altKey=N,this.metaKey=n,this.keyLabel=r,this.keyAriaLabel=l}}t.ResolvedKeybindingPart=m;class v{}t.ResolvedKeybinding=v}),$(z[7],V([0,1,15,16]),function(I,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const p=!1;let s=null;function d(l){s=l}if(t.setDisposableTracker=d,p){const l="__is_disposable_tracked__";d(new class{trackDisposable(g){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[l]||console.log(C)},3e3)}setParent(g,C){if(g&&g!==N.None)try{g[l]=!0}catch(b){}}markAsDisposed(g){if(g&&g!==N.None)try{g[l]=!0}catch(C){}}markAsSingleton(g){}})}function a(l){return s==null||s.trackDisposable(l),l}function o(l){s==null||s.markAsDisposed(l)}function f(l,g){s==null||s.setParent(l,g)}function S(l,g){if(!!s)for(const C of l)s.setParent(C,g)}function c(l){return s==null||s.markAsSingleton(l),l}t.markAsSingleton=c;class h extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}t.MultiDisposeError=h;function m(l){return typeof l.dispose=="function"&&l.dispose.length===0}t.isDisposable=m;function v(l){if(M.Iterable.is(l)){let g=[];for(const C of l)if(C)try{C.dispose()}catch(b){g.push(b)}if(g.length===1)throw g[0];if(g.length>1)throw new h(g);return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}t.dispose=v;function i(...l){const g=u(()=>v(l));return S(l,g),g}t.combinedDisposable=i;function u(l){const g=a({dispose:(0,E.once)(()=>{o(g),l()})});return g}t.toDisposable=u;class _{constructor(){this._toDispose=new Set,this._isDisposed=!1,a(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return f(g,this),this._isDisposed?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}t.DisposableStore=_,_.DISABLE_DISPOSED_WARNING=!1;class N{constructor(){this._store=new _,a(this),f(this._store,this)}dispose(){o(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}t.Disposable=N,N.None=Object.freeze({dispose(){}});class n{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){var C;this._isDisposed||g===this._value||((C=this._value)===null||C===void 0||C.dispose(),g&&f(g,this),this._value=g)}clear(){this.value=void 0}dispose(){var g;this._isDisposed=!0,o(this),(g=this._value)===null||g===void 0||g.dispose(),this._value=void 0}clearAndLeak(){const g=this._value;return this._value=void 0,g&&f(g,null),g}}t.MutableDisposable=n;class r{constructor(g){this.object=g}dispose(){}}t.ImmortalReference=r}),$(z[18],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(s){this.element=s,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let s=this._first;for(;s!==E.Undefined;){const d=s.next;s.prev=E.Undefined,s.next=E.Undefined,s=d}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(s){return this._insert(s,!1)}push(s){return this._insert(s,!0)}_insert(s,d){const a=new E(s);if(this._first===E.Undefined)this._first=a,this._last=a;else if(d){const f=this._last;this._last=a,a.prev=f,f.next=a}else{const f=this._first;this._first=a,a.next=f,f.prev=a}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(a))}}shift(){if(this._first!==E.Undefined){const s=this._first.element;return this._remove(this._first),s}}pop(){if(this._last!==E.Undefined){const s=this._last.element;return this._remove(this._last),s}}_remove(s){if(s.prev!==E.Undefined&&s.next!==E.Undefined){const d=s.prev;d.next=s.next,s.next.prev=d}else s.prev===E.Undefined&&s.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):s.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):s.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let s=this._first;for(;s!==E.Undefined;)yield s.element,s=s.next}}t.LinkedList=M}),$(z[2],V([0,1]),function(I,t){"use strict";var E;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.setImmediate=t.userAgent=t.isIOS=t.isWeb=t.isNative=t.isLinux=t.isMacintosh=t.isWindows=t.globals=void 0;const M="en";let p=!1,s=!1,d=!1,a=!1,o=!1,f=!1,S=!1,c,h=M,m,v;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let i;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?i=t.globals.vscode.process:typeof process!="undefined"&&(i=process);const u=typeof((E=i==null?void 0:i.versions)===null||E===void 0?void 0:E.electron)=="string"&&i.type==="renderer";if(typeof navigator=="object"&&!u)v=navigator.userAgent,p=v.indexOf("Windows")>=0,s=v.indexOf("Macintosh")>=0,S=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,d=v.indexOf("Linux")>=0,f=!0,c=navigator.language,h=c;else if(typeof i=="object"){p=i.platform==="win32",s=i.platform==="darwin",d=i.platform==="linux",a=d&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,c=M,h=M;const l=i.env.VSCODE_NLS_CONFIG;if(l)try{const g=JSON.parse(l),C=g.availableLanguages["*"];c=g.locale,h=C||M,m=g._translationsConfigFile}catch(g){}o=!0}else console.error("Unable to resolve platform.");let _=0;s?_=1:p?_=3:d&&(_=2),t.isWindows=p,t.isMacintosh=s,t.isLinux=d,t.isNative=o,t.isWeb=f,t.isIOS=S,t.userAgent=v,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let C=[];t.globals.addEventListener("message",L=>{if(L.data&&L.data.vscodeSetImmediateId)for(let w=0,y=C.length;w<y;w++){const P=C[w];if(P.id===L.data.vscodeSetImmediateId){C.splice(w,1),P.callback();return}}});let b=0;return L=>{const w=++b;C.push({id:w,callback:L}),t.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(i==null?void 0:i.nextTick)=="function")return i.nextTick.bind(i);const g=Promise.resolve();return C=>g.then(C)}(),t.OS=s||S?2:p?1:3;let N=!0,n=!1;function r(){if(!n){n=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,N=new Uint16Array(l.buffer)[0]===(2<<8)+1}return N}t.isLittleEndian=r}),$(z[19],V([0,1,2]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.platform=t.env=t.cwd=void 0;let M;if(typeof E.globals.vscode!="undefined"&&typeof E.globals.vscode.process!="undefined"){const p=E.globals.vscode.process;M={get platform(){return p.platform},get arch(){return p.arch},get env(){return p.env},cwd(){return p.cwd()},nextTick(s){return(0,E.setImmediate)(s)}}}else typeof process!="undefined"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(p){return process.nextTick(p)}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},nextTick(p){return(0,E.setImmediate)(p)},get env(){return{}},cwd(){return"/"}};t.cwd=M.cwd,t.env=M.env,t.platform=M.platform}),$(z[20],V([0,1,19]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sep=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.normalize=t.posix=t.win32=void 0;const M=65,p=97,s=90,d=122,a=46,o=47,f=92,S=58,c=63;class h extends Error{constructor(r,l,g){let C;typeof l=="string"&&l.indexOf("not ")===0?(C="must not be",l=l.replace(/^not /,"")):C="must be";const b=r.indexOf(".")!==-1?"property":"argument";let L=`The "${r}" ${b} ${C} of type ${l}`;L+=`. Received type ${typeof g}`,super(L),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,r){if(typeof n!="string")throw new h(r,"string",n)}function v(n){return n===o||n===f}function i(n){return n===o}function u(n){return n>=M&&n<=s||n>=p&&n<=d}function _(n,r,l,g){let C="",b=0,L=-1,w=0,y=0;for(let P=0;P<=n.length;++P){if(P<n.length)y=n.charCodeAt(P);else{if(g(y))break;y=o}if(g(y)){if(!(L===P-1||w===1))if(w===2){if(C.length<2||b!==2||C.charCodeAt(C.length-1)!==a||C.charCodeAt(C.length-2)!==a){if(C.length>2){const U=C.lastIndexOf(l);U===-1?(C="",b=0):(C=C.slice(0,U),b=C.length-1-C.lastIndexOf(l)),L=P,w=0;continue}else if(C.length!==0){C="",b=0,L=P,w=0;continue}}r&&(C+=C.length>0?`${l}..`:"..",b=2)}else C.length>0?C+=`${l}${n.slice(L+1,P)}`:C=n.slice(L+1,P),b=P-L-1;L=P,w=0}else y===a&&w!==-1?++w:w=-1}return C}function N(n,r){if(r===null||typeof r!="object")throw new h("pathObject","Object",r);const l=r.dir||r.root,g=r.base||`${r.name||""}${r.ext||""}`;return l?l===r.root?`${l}${g}`:`${l}${n}${g}`:g}t.win32={resolve(...n){let r="",l="",g=!1;for(let C=n.length-1;C>=-1;C--){let b;if(C>=0){if(b=n[C],m(b,"path"),b.length===0)continue}else r.length===0?b=E.cwd():(b=E.env[`=${r}`]||E.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==r.toLowerCase()&&b.charCodeAt(2)===f)&&(b=`${r}\\`));const L=b.length;let w=0,y="",P=!1;const U=b.charCodeAt(0);if(L===1)v(U)&&(w=1,P=!0);else if(v(U))if(P=!0,v(b.charCodeAt(1))){let R=2,W=R;for(;R<L&&!v(b.charCodeAt(R));)R++;if(R<L&&R!==W){const Y=b.slice(W,R);for(W=R;R<L&&v(b.charCodeAt(R));)R++;if(R<L&&R!==W){for(W=R;R<L&&!v(b.charCodeAt(R));)R++;(R===L||R!==W)&&(y=`\\\\${Y}\\${b.slice(W,R)}`,w=R)}}}else w=1;else u(U)&&b.charCodeAt(1)===S&&(y=b.slice(0,2),w=2,L>2&&v(b.charCodeAt(2))&&(P=!0,w=3));if(y.length>0)if(r.length>0){if(y.toLowerCase()!==r.toLowerCase())continue}else r=y;if(g){if(r.length>0)break}else if(l=`${b.slice(w)}\\${l}`,g=P,P&&r.length>0)break}return l=_(l,!g,"\\",v),g?`${r}\\${l}`:`${r}${l}`||"."},normalize(n){m(n,"path");const r=n.length;if(r===0)return".";let l=0,g,C=!1;const b=n.charCodeAt(0);if(r===1)return i(b)?"\\":n;if(v(b))if(C=!0,v(n.charCodeAt(1))){let w=2,y=w;for(;w<r&&!v(n.charCodeAt(w));)w++;if(w<r&&w!==y){const P=n.slice(y,w);for(y=w;w<r&&v(n.charCodeAt(w));)w++;if(w<r&&w!==y){for(y=w;w<r&&!v(n.charCodeAt(w));)w++;if(w===r)return`\\\\${P}\\${n.slice(y)}\\`;w!==y&&(g=`\\\\${P}\\${n.slice(y,w)}`,l=w)}}}else l=1;else u(b)&&n.charCodeAt(1)===S&&(g=n.slice(0,2),l=2,r>2&&v(n.charCodeAt(2))&&(C=!0,l=3));let L=l<r?_(n.slice(l),!C,"\\",v):"";return L.length===0&&!C&&(L="."),L.length>0&&v(n.charCodeAt(r-1))&&(L+="\\"),g===void 0?C?`\\${L}`:L:C?`${g}\\${L}`:`${g}${L}`},isAbsolute(n){m(n,"path");const r=n.length;if(r===0)return!1;const l=n.charCodeAt(0);return v(l)||r>2&&u(l)&&n.charCodeAt(1)===S&&v(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,l;for(let b=0;b<n.length;++b){const L=n[b];m(L,"path"),L.length>0&&(r===void 0?r=l=L:r+=`\\${L}`)}if(r===void 0)return".";let g=!0,C=0;if(typeof l=="string"&&v(l.charCodeAt(0))){++C;const b=l.length;b>1&&v(l.charCodeAt(1))&&(++C,b>2&&(v(l.charCodeAt(2))?++C:g=!1))}if(g){for(;C<r.length&&v(r.charCodeAt(C));)C++;C>=2&&(r=`\\${r.slice(C)}`)}return t.win32.normalize(r)},relative(n,r){if(m(n,"from"),m(r,"to"),n===r)return"";const l=t.win32.resolve(n),g=t.win32.resolve(r);if(l===g||(n=l.toLowerCase(),r=g.toLowerCase(),n===r))return"";let C=0;for(;C<n.length&&n.charCodeAt(C)===f;)C++;let b=n.length;for(;b-1>C&&n.charCodeAt(b-1)===f;)b--;const L=b-C;let w=0;for(;w<r.length&&r.charCodeAt(w)===f;)w++;let y=r.length;for(;y-1>w&&r.charCodeAt(y-1)===f;)y--;const P=y-w,U=L<P?L:P;let R=-1,W=0;for(;W<U;W++){const k=n.charCodeAt(C+W);if(k!==r.charCodeAt(w+W))break;k===f&&(R=W)}if(W!==U){if(R===-1)return g}else{if(P>U){if(r.charCodeAt(w+W)===f)return g.slice(w+W+1);if(W===2)return g.slice(w+W)}L>U&&(n.charCodeAt(C+W)===f?R=W:W===2&&(R=3)),R===-1&&(R=0)}let Y="";for(W=C+R+1;W<=b;++W)(W===b||n.charCodeAt(W)===f)&&(Y+=Y.length===0?"..":"\\..");return w+=R,Y.length>0?`${Y}${g.slice(w,y)}`:(g.charCodeAt(w)===f&&++w,g.slice(w,y))},toNamespacedPath(n){if(typeof n!="string")return n;if(n.length===0)return"";const r=t.win32.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===f){if(r.charCodeAt(1)===f){const l=r.charCodeAt(2);if(l!==c&&l!==a)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===S&&r.charCodeAt(2)===f)return`\\\\?\\${r}`;return n},dirname(n){m(n,"path");const r=n.length;if(r===0)return".";let l=-1,g=0;const C=n.charCodeAt(0);if(r===1)return v(C)?n:".";if(v(C)){if(l=g=1,v(n.charCodeAt(1))){let w=2,y=w;for(;w<r&&!v(n.charCodeAt(w));)w++;if(w<r&&w!==y){for(y=w;w<r&&v(n.charCodeAt(w));)w++;if(w<r&&w!==y){for(y=w;w<r&&!v(n.charCodeAt(w));)w++;if(w===r)return n;w!==y&&(l=g=w+1)}}}}else u(C)&&n.charCodeAt(1)===S&&(l=r>2&&v(n.charCodeAt(2))?3:2,g=l);let b=-1,L=!0;for(let w=r-1;w>=g;--w)if(v(n.charCodeAt(w))){if(!L){b=w;break}}else L=!1;if(b===-1){if(l===-1)return".";b=l}return n.slice(0,b)},basename(n,r){r!==void 0&&m(r,"ext"),m(n,"path");let l=0,g=-1,C=!0,b;if(n.length>=2&&u(n.charCodeAt(0))&&n.charCodeAt(1)===S&&(l=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let L=r.length-1,w=-1;for(b=n.length-1;b>=l;--b){const y=n.charCodeAt(b);if(v(y)){if(!C){l=b+1;break}}else w===-1&&(C=!1,w=b+1),L>=0&&(y===r.charCodeAt(L)?--L==-1&&(g=b):(L=-1,g=w))}return l===g?g=w:g===-1&&(g=n.length),n.slice(l,g)}for(b=n.length-1;b>=l;--b)if(v(n.charCodeAt(b))){if(!C){l=b+1;break}}else g===-1&&(C=!1,g=b+1);return g===-1?"":n.slice(l,g)},extname(n){m(n,"path");let r=0,l=-1,g=0,C=-1,b=!0,L=0;n.length>=2&&n.charCodeAt(1)===S&&u(n.charCodeAt(0))&&(r=g=2);for(let w=n.length-1;w>=r;--w){const y=n.charCodeAt(w);if(v(y)){if(!b){g=w+1;break}continue}C===-1&&(b=!1,C=w+1),y===a?l===-1?l=w:L!==1&&(L=1):l!==-1&&(L=-1)}return l===-1||C===-1||L===0||L===1&&l===C-1&&l===g+1?"":n.slice(l,C)},format:N.bind(null,"\\"),parse(n){m(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const l=n.length;let g=0,C=n.charCodeAt(0);if(l===1)return v(C)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(v(C)){if(g=1,v(n.charCodeAt(1))){let R=2,W=R;for(;R<l&&!v(n.charCodeAt(R));)R++;if(R<l&&R!==W){for(W=R;R<l&&v(n.charCodeAt(R));)R++;if(R<l&&R!==W){for(W=R;R<l&&!v(n.charCodeAt(R));)R++;R===l?g=R:R!==W&&(g=R+1)}}}}else if(u(C)&&n.charCodeAt(1)===S){if(l<=2)return r.root=r.dir=n,r;if(g=2,v(n.charCodeAt(2))){if(l===3)return r.root=r.dir=n,r;g=3}}g>0&&(r.root=n.slice(0,g));let b=-1,L=g,w=-1,y=!0,P=n.length-1,U=0;for(;P>=g;--P){if(C=n.charCodeAt(P),v(C)){if(!y){L=P+1;break}continue}w===-1&&(y=!1,w=P+1),C===a?b===-1?b=P:U!==1&&(U=1):b!==-1&&(U=-1)}return w!==-1&&(b===-1||U===0||U===1&&b===w-1&&b===L+1?r.base=r.name=n.slice(L,w):(r.name=n.slice(L,b),r.base=n.slice(L,w),r.ext=n.slice(b,w))),L>0&&L!==g?r.dir=n.slice(0,L-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...n){let r="",l=!1;for(let g=n.length-1;g>=-1&&!l;g--){const C=g>=0?n[g]:E.cwd();m(C,"path"),C.length!==0&&(r=`${C}/${r}`,l=C.charCodeAt(0)===o)}return r=_(r,!l,"/",i),l?`/${r}`:r.length>0?r:"."},normalize(n){if(m(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===o,l=n.charCodeAt(n.length-1)===o;return n=_(n,!r,"/",i),n.length===0?r?"/":l?"./":".":(l&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return m(n,"path"),n.length>0&&n.charCodeAt(0)===o},join(...n){if(n.length===0)return".";let r;for(let l=0;l<n.length;++l){const g=n[l];m(g,"path"),g.length>0&&(r===void 0?r=g:r+=`/${g}`)}return r===void 0?".":t.posix.normalize(r)},relative(n,r){if(m(n,"from"),m(r,"to"),n===r||(n=t.posix.resolve(n),r=t.posix.resolve(r),n===r))return"";const l=1,g=n.length,C=g-l,b=1,L=r.length-b,w=C<L?C:L;let y=-1,P=0;for(;P<w;P++){const R=n.charCodeAt(l+P);if(R!==r.charCodeAt(b+P))break;R===o&&(y=P)}if(P===w)if(L>w){if(r.charCodeAt(b+P)===o)return r.slice(b+P+1);if(P===0)return r.slice(b+P)}else C>w&&(n.charCodeAt(l+P)===o?y=P:P===0&&(y=0));let U="";for(P=l+y+1;P<=g;++P)(P===g||n.charCodeAt(P)===o)&&(U+=U.length===0?"..":"/..");return`${U}${r.slice(b+y)}`},toNamespacedPath(n){return n},dirname(n){if(m(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===o;let l=-1,g=!0;for(let C=n.length-1;C>=1;--C)if(n.charCodeAt(C)===o){if(!g){l=C;break}}else g=!1;return l===-1?r?"/":".":r&&l===1?"//":n.slice(0,l)},basename(n,r){r!==void 0&&m(r,"ext"),m(n,"path");let l=0,g=-1,C=!0,b;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let L=r.length-1,w=-1;for(b=n.length-1;b>=0;--b){const y=n.charCodeAt(b);if(y===o){if(!C){l=b+1;break}}else w===-1&&(C=!1,w=b+1),L>=0&&(y===r.charCodeAt(L)?--L==-1&&(g=b):(L=-1,g=w))}return l===g?g=w:g===-1&&(g=n.length),n.slice(l,g)}for(b=n.length-1;b>=0;--b)if(n.charCodeAt(b)===o){if(!C){l=b+1;break}}else g===-1&&(C=!1,g=b+1);return g===-1?"":n.slice(l,g)},extname(n){m(n,"path");let r=-1,l=0,g=-1,C=!0,b=0;for(let L=n.length-1;L>=0;--L){const w=n.charCodeAt(L);if(w===o){if(!C){l=L+1;break}continue}g===-1&&(C=!1,g=L+1),w===a?r===-1?r=L:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||g===-1||b===0||b===1&&r===g-1&&r===l+1?"":n.slice(r,g)},format:N.bind(null,"/"),parse(n){m(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const l=n.charCodeAt(0)===o;let g;l?(r.root="/",g=1):g=0;let C=-1,b=0,L=-1,w=!0,y=n.length-1,P=0;for(;y>=g;--y){const U=n.charCodeAt(y);if(U===o){if(!w){b=y+1;break}continue}L===-1&&(w=!1,L=y+1),U===a?C===-1?C=y:P!==1&&(P=1):C!==-1&&(P=-1)}if(L!==-1){const U=b===0&&l?1:b;C===-1||P===0||P===1&&C===L-1&&C===b+1?r.base=r.name=n.slice(U,L):(r.name=n.slice(U,C),r.base=n.slice(U,L),r.ext=n.slice(C,L))}return b>0?r.dir=n.slice(0,b-1):l&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=E.platform==="win32"?t.win32.normalize:t.posix.normalize,t.resolve=E.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=E.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=E.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=E.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=E.platform==="win32"?t.win32.extname:t.posix.extname,t.sep=E.platform==="win32"?t.win32.sep:t.posix.sep}),$(z[8],V([0,1,2]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const M=E.globals.performance&&typeof E.globals.performance.now=="function";class p{constructor(d){this._highResolution=M&&d,this._startTime=this._now(),this._stopTime=-1}static create(d=!0){return new p(d)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}t.StopWatch=p}),$(z[9],V([0,1,4,7,18,8]),function(I,t,E,M,p,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.DebounceEmitter=t.PauseableEmitter=t.Emitter=t.Event=void 0;var d;(function(i){i.None=()=>M.Disposable.None;function u(k){return(F,B=null,H)=>{let e=!1,q;return q=k(G=>{if(!e)return q?q.dispose():e=!0,F.call(B,G)},null,H),e&&q.dispose(),q}}i.once=u;function _(k,F){return C((B,H=null,e)=>k(q=>B.call(H,F(q)),null,e))}i.map=_;function N(k,F){return C((B,H=null,e)=>k(q=>{F(q),B.call(H,q)},null,e))}i.forEach=N;function n(k,F){return C((B,H=null,e)=>k(q=>F(q)&&B.call(H,q),null,e))}i.filter=n;function r(k){return k}i.signal=r;function l(...k){return(F,B=null,H)=>(0,M.combinedDisposable)(...k.map(e=>e(q=>F.call(B,q),null,H)))}i.any=l;function g(k,F,B){let H=B;return _(k,e=>(H=F(H,e),H))}i.reduce=g;function C(k){let F;const B=new S({onFirstListenerAdd(){F=k(B.fire,B)},onLastListenerRemove(){F.dispose()}});return B.event}function b(k,F,B=100,H=!1,e){let q,G,Z,ie=0;const re=new S({leakWarningThreshold:e,onFirstListenerAdd(){q=k(le=>{ie++,G=F(G,le),H&&!Z&&(re.fire(G),G=void 0),clearTimeout(Z),Z=setTimeout(()=>{const ue=G;G=void 0,Z=void 0,(!H||ie>1)&&re.fire(ue),ie=0},B)})},onLastListenerRemove(){q.dispose()}});return re.event}i.debounce=b;function L(k,F=(B,H)=>B===H){let B=!0,H;return n(k,e=>{const q=B||!F(e,H);return B=!1,H=e,q})}i.latch=L;function w(k,F){return[i.filter(k,F),i.filter(k,B=>!F(B))]}i.split=w;function y(k,F=!1,B=[]){let H=B.slice(),e=k(Z=>{H?H.push(Z):G.fire(Z)});const q=()=>{H&&H.forEach(Z=>G.fire(Z)),H=null},G=new S({onFirstListenerAdd(){e||(e=k(Z=>G.fire(Z)))},onFirstListenerDidAdd(){H&&(F?setTimeout(q):q())},onLastListenerRemove(){e&&e.dispose(),e=null}});return G.event}i.buffer=y;class P{constructor(F){this.event=F}map(F){return new P(_(this.event,F))}forEach(F){return new P(N(this.event,F))}filter(F){return new P(n(this.event,F))}reduce(F,B){return new P(g(this.event,F,B))}latch(){return new P(L(this.event))}debounce(F,B=100,H=!1,e){return new P(b(this.event,F,B,H,e))}on(F,B,H){return this.event(F,B,H)}once(F,B,H){return u(this.event)(F,B,H)}}function U(k){return new P(k)}i.chain=U;function R(k,F,B=H=>H){const H=(...Z)=>G.fire(B(...Z)),e=()=>k.on(F,H),q=()=>k.removeListener(F,H),G=new S({onFirstListenerAdd:e,onLastListenerRemove:q});return G.event}i.fromNodeEventEmitter=R;function W(k,F,B=H=>H){const H=(...Z)=>G.fire(B(...Z)),e=()=>k.addEventListener(F,H),q=()=>k.removeEventListener(F,H),G=new S({onFirstListenerAdd:e,onLastListenerRemove:q});return G.event}i.fromDOMEventEmitter=W;function Y(k){return new Promise(F=>u(k)(F))}i.toPromise=Y})(d=t.Event||(t.Event={}));class a{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${a._idPool++}`}start(u){this._stopWatch=new s.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}a._idPool=0;let o=-1;class f{constructor(u,_=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=_,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let _=o;if(typeof this.customThreshold=="number"&&(_=this.customThreshold),_<=0||u<_)return;this._stacks||(this._stacks=new Map);const N=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(N)||0;if(this._stacks.set(N,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let r,l=0;for(const[g,C]of this._stacks)(!r||l<C)&&(r=g,l=C);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${l}):`),console.warn(r)}return()=>{const r=this._stacks.get(N)||0;this._stacks.set(N,r-1)}}}class S{constructor(u){var _;this._disposed=!1,this._options=u,this._leakageMon=o>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((_=this._options)===null||_===void 0?void 0:_._profName)?new a(this._options._profName):void 0}get event(){return this._event||(this._event=(u,_,N)=>{var n;this._listeners||(this._listeners=new p.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const l=this._listeners.push(_?[u,_]:u);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,_);const g=(n=this._leakageMon)===null||n===void 0?void 0:n.check(this._listeners.size),C=(0,M.toDisposable)(()=>{g&&g(),this._disposed||(l(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return N instanceof M.DisposableStore?N.add(C):Array.isArray(N)&&N.push(C),C}),this._event}fire(u){var _,N;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,u]);for((_=this._perfMon)===null||_===void 0||_.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,r]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,r):n[0].call(n[1],r)}catch(l){(0,E.onUnexpectedError)(l)}}(N=this._perfMon)===null||N===void 0||N.stop()}}dispose(){var u,_,N,n,r;this._disposed||(this._disposed=!0,(u=this._listeners)===null||u===void 0||u.clear(),(_=this._deliveryQueue)===null||_===void 0||_.clear(),(n=(N=this._options)===null||N===void 0?void 0:N.onLastListenerRemove)===null||n===void 0||n.call(N),(r=this._leakageMon)===null||r===void 0||r.dispose())}}t.Emitter=S;class c extends S{constructor(u){super(u);this._isPaused=0,this._eventQueue=new p.LinkedList,this._mergeFn=u==null?void 0:u.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}t.PauseableEmitter=c;class h extends c{constructor(u){var _;super(u);this._delay=(_=u.delay)!==null&&_!==void 0?_:100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}t.DebounceEmitter=h;class m{constructor(){this.buffers=[]}wrapEvent(u){return(_,N,n)=>u(r=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>_.call(N,r)):_.call(N,r)},void 0,n)}bufferEvents(u){const _=[];this.buffers.push(_);const N=u();return this.buffers.pop(),_.forEach(n=>n()),N}}t.EventBufferer=m;class v{constructor(){this.listening=!1,this.inputEvent=d.None,this.inputEventListener=M.Disposable.None,this.emitter=new S({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=v}),$(z[21],V([0,1,9]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const M=Object.freeze(function(a,o){const f=setTimeout(a.bind(o),0);return{dispose(){clearTimeout(f)}}});var p;(function(a){function o(f){return f===a.None||f===a.Cancelled||f instanceof s?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}a.isCancellationToken=o,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(p=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class d{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=p.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=p.None}}t.CancellationTokenSource=d}),$(z[5],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLeftDeleteOffset=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.containsUppercaseCharacter=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0;function E(A){return!A||typeof A!="string"?!0:A.trim().length===0}t.isFalsyOrWhitespace=E;const M=/{(\d+)}/g;function p(A,...D){return D.length===0?A:A.replace(M,function(T,O){const j=parseInt(O,10);return isNaN(j)||j<0||j>=D.length?T:D[j]})}t.format=p;function s(A){return A.replace(/[<>&]/g,function(D){switch(D){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return D}})}t.escape=s;function d(A){return A.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=d;function a(A,D=" "){const T=o(A,D);return f(T,D)}t.trim=a;function o(A,D){if(!A||!D)return A;const T=D.length;if(T===0||A.length===0)return A;let O=0;for(;A.indexOf(D,O)===O;)O=O+T;return A.substring(O)}t.ltrim=o;function f(A,D){if(!A||!D)return A;const T=D.length,O=A.length;if(T===0||O===0)return A;let j=O,Q=-1;for(;Q=A.lastIndexOf(D,j-1),!(Q===-1||Q+T!==j);){if(Q===0)return"";j=Q}return A.substring(0,j)}t.rtrim=f;function S(A){return A.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=S;function c(A){return A.replace(/\*/g,"")}t.stripWildcards=c;function h(A,D,T={}){if(!A)throw new Error("Cannot create regex from empty string");D||(A=d(A)),T.wholeWord&&(/\B/.test(A.charAt(0))||(A="\\b"+A),/\B/.test(A.charAt(A.length-1))||(A=A+"\\b"));let O="";return T.global&&(O+="g"),T.matchCase||(O+="i"),T.multiline&&(O+="m"),T.unicode&&(O+="u"),new RegExp(A,O)}t.createRegExp=h;function m(A){return A.source==="^"||A.source==="^$"||A.source==="$"||A.source==="^\\s*$"?!1:!!(A.exec("")&&A.lastIndex===0)}t.regExpLeadsToEndlessLoop=m;function v(A){return(A.global?"g":"")+(A.ignoreCase?"i":"")+(A.multiline?"m":"")+(A.unicode?"u":"")}t.regExpFlags=v;function i(A){return A.split(/\r\n|\r|\n/)}t.splitLines=i;function u(A){for(let D=0,T=A.length;D<T;D++){const O=A.charCodeAt(D);if(O!==32&&O!==9)return D}return-1}t.firstNonWhitespaceIndex=u;function _(A,D=0,T=A.length){for(let O=D;O<T;O++){const j=A.charCodeAt(O);if(j!==32&&j!==9)return A.substring(D,O)}return A.substring(D,T)}t.getLeadingWhitespace=_;function N(A,D=A.length-1){for(let T=D;T>=0;T--){const O=A.charCodeAt(T);if(O!==32&&O!==9)return T}return-1}t.lastNonWhitespaceIndex=N;function n(A,D){return A<D?-1:A>D?1:0}t.compare=n;function r(A,D,T=0,O=A.length,j=0,Q=D.length){for(;T<O&&j<Q;T++,j++){let K=A.charCodeAt(T),te=D.charCodeAt(j);if(K<te)return-1;if(K>te)return 1}const J=O-T,x=Q-j;return J<x?-1:J>x?1:0}t.compareSubstring=r;function l(A,D){return g(A,D,0,A.length,0,D.length)}t.compareIgnoreCase=l;function g(A,D,T=0,O=A.length,j=0,Q=D.length){for(;T<O&&j<Q;T++,j++){let K=A.charCodeAt(T),te=D.charCodeAt(j);if(K===te)continue;const ae=K-te;if(!(ae===32&&b(te))&&!(ae===-32&&b(K)))return C(K)&&C(te)?ae:r(A.toLowerCase(),D.toLowerCase(),T,O,j,Q)}const J=O-T,x=Q-j;return J<x?-1:J>x?1:0}t.compareSubstringIgnoreCase=g;function C(A){return A>=97&&A<=122}t.isLowerAsciiLetter=C;function b(A){return A>=65&&A<=90}t.isUpperAsciiLetter=b;function L(A){return C(A)||b(A)}function w(A,D){return A.length===D.length&&y(A,D)}t.equalsIgnoreCase=w;function y(A,D,T=A.length){for(let O=0;O<T;O++){const j=A.charCodeAt(O),Q=D.charCodeAt(O);if(j!==Q){if(L(j)&&L(Q)){const J=Math.abs(j-Q);if(J!==0&&J!==32)return!1}else if(String.fromCharCode(j).toLowerCase()!==String.fromCharCode(Q).toLowerCase())return!1}}return!0}function P(A,D){const T=D.length;return D.length>A.length?!1:y(A,D,T)}t.startsWithIgnoreCase=P;function U(A,D){let T,O=Math.min(A.length,D.length);for(T=0;T<O;T++)if(A.charCodeAt(T)!==D.charCodeAt(T))return T;return O}t.commonPrefixLength=U;function R(A,D){let T,O=Math.min(A.length,D.length);const j=A.length-1,Q=D.length-1;for(T=0;T<O;T++)if(A.charCodeAt(j-T)!==D.charCodeAt(Q-T))return T;return O}t.commonSuffixLength=R;function W(A){return 55296<=A&&A<=56319}t.isHighSurrogate=W;function Y(A){return 56320<=A&&A<=57343}t.isLowSurrogate=Y;function k(A,D){return(A-55296<<10)+(D-56320)+65536}t.computeCodePoint=k;function F(A,D,T){const O=A.charCodeAt(T);if(W(O)&&T+1<D){const j=A.charCodeAt(T+1);if(Y(j))return k(O,j)}return O}t.getNextCodePoint=F;function B(A,D){const T=A.charCodeAt(D-1);if(Y(T)&&D>1){const O=A.charCodeAt(D-2);if(W(O))return k(O,T)}return T}function H(A,D){const T=ee.getInstance(),O=D,j=A.length,Q=F(A,j,D);D+=Q>=65536?2:1;let J=T.getGraphemeBreakType(Q);for(;D<j;){const x=F(A,j,D),K=T.getGraphemeBreakType(x);if(oe(J,K))break;D+=x>=65536?2:1,J=K}return D-O}t.nextCharLength=H;function e(A,D){const T=ee.getInstance(),O=D,j=B(A,D);D-=j>=65536?2:1;let Q=T.getGraphemeBreakType(j);for(;D>0;){const J=B(A,D),x=T.getGraphemeBreakType(J);if(oe(x,Q))break;D-=J>=65536?2:1,Q=x}return O-D}t.prevCharLength=e;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(A){return q.test(A)}t.containsRTL=G;const Z=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ie(A){return Z.test(A)}t.containsEmoji=ie;const re=/^[\t\n\r\x20-\x7E]*$/;function le(A){return re.test(A)}t.isBasicASCII=le,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ue(A){return t.UNUSUAL_LINE_TERMINATORS.test(A)}t.containsUnusualLineTerminators=ue;function me(A){for(let D=0,T=A.length;D<T;D++)if(ce(A.charCodeAt(D)))return!0;return!1}t.containsFullWidthCharacter=me;function ce(A){return A=+A,A>=11904&&A<=55215||A>=63744&&A<=64255||A>=65281&&A<=65374}t.isFullWidthCharacter=ce;function fe(A){return A>=127462&&A<=127487||A===8986||A===8987||A===9200||A===9203||A>=9728&&A<=10175||A===11088||A===11093||A>=127744&&A<=128591||A>=128640&&A<=128764||A>=128992&&A<=129003||A>=129280&&A<=129535||A>=129648&&A<=129750}t.isEmojiImprecise=fe,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(A){return!!(A&&A.length>0&&A.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ge;function _e(A,D=!1){return A?(D&&(A=A.replace(/\\./g,"")),A.toLowerCase()!==A):!1}t.containsUppercaseCharacter=_e;function ve(A){const D=90-65+1;return A=A%(2*D),A<D?String.fromCharCode(97+A):String.fromCharCode(65+A-D)}t.singleLetterHash=ve;function Ce(A){return ee.getInstance().getGraphemeBreakType(A)}t.getGraphemeBreakType=Ce;function oe(A,D){return A===0?D!==5&&D!==7:A===2&&D===3?!1:A===4||A===2||A===3||D===4||D===2||D===3?!0:!(A===8&&(D===8||D===9||D===11||D===12)||(A===11||A===9)&&(D===9||D===10)||(A===12||A===10)&&D===10||D===5||D===13||D===7||A===1||A===13&&D===14||A===6&&D===6)}t.breakBetweenGraphemeBreakType=oe;class ee{constructor(){this._data=be()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(D){if(D<32)return D===10?3:D===13?2:4;if(D<127)return 0;const T=this._data,O=T.length/3;let j=1;for(;j<=O;)if(D<T[3*j])j=2*j;else if(D>T[3*j+1])j=2*j+1;else return T[3*j+2];return 0}}ee._INSTANCE=null;function be(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(A,D){if(A===0)return 0;const T=Le(A,D);if(T!==void 0)return T;const O=B(D,A);return A-=se(O),A}t.getLeftDeleteOffset=Se;function Le(A,D){let T=B(D,A);for(A-=se(T);Ne(T)||T===65039||T===8419;){if(A===0)return;T=B(D,A),A-=se(T)}if(!!fe(T)){if(A>=0){const O=B(D,A);O===8205&&(A-=se(O))}return A}}function se(A){return A>=65536?2:1}function Ne(A){return 127995<=A&&A<=127999}}),$(z[22],V([0,1,5]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function M(i){return p(i,0)}t.hash=M;function p(i,u){switch(typeof i){case"object":return i===null?s(349,u):Array.isArray(i)?o(i,u):f(i,u);case"string":return a(i,u);case"boolean":return d(i,u);case"number":return s(i,u);case"undefined":return s(937,u);default:return s(617,u)}}t.doHash=p;function s(i,u){return(u<<5)-u+i|0}t.numberHash=s;function d(i,u){return s(i?433:863,u)}function a(i,u){u=s(149417,u);for(let _=0,N=i.length;_<N;_++)u=s(i.charCodeAt(_),u);return u}t.stringHash=a;function o(i,u){return u=s(104579,u),i.reduce((_,N)=>p(N,_),u)}function f(i,u){return u=s(181387,u),Object.keys(i).sort().reduce((_,N)=>(_=a(N,_),p(i[N],_)),u)}function S(i,u,_=32){const N=_-u,n=~((1<<N)-1);return(i<<u|(n&i)>>>N)>>>0}function c(i,u=0,_=i.byteLength,N=0){for(let n=0;n<_;n++)i[u+n]=N}function h(i,u,_="0"){for(;i.length<u;)i=_+i;return i}function m(i,u=32){return i instanceof ArrayBuffer?Array.from(new Uint8Array(i)).map(_=>_.toString(16).padStart(2,"0")).join(""):h((i>>>0).toString(16),u/4)}t.toHexString=m;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const _=u.length;if(_===0)return;const N=this._buff;let n=this._buffLen,r=this._leftoverHighSurrogate,l,g;for(r!==0?(l=r,g=-1,r=0):(l=u.charCodeAt(0),g=0);;){let C=l;if(E.isHighSurrogate(l))if(g+1<_){const b=u.charCodeAt(g+1);E.isLowSurrogate(b)?(g++,C=E.computeCodePoint(l,b)):C=65533}else{r=l;break}else E.isLowSurrogate(l)&&(C=65533);if(n=this._push(N,n,C),g++,g<_)l=u.charCodeAt(g);else break}this._buffLen=n,this._leftoverHighSurrogate=r}_push(u,_,N){return N<128?u[_++]=N:N<2048?(u[_++]=192|(N&1984)>>>6,u[_++]=128|(N&63)>>>0):N<65536?(u[_++]=224|(N&61440)>>>12,u[_++]=128|(N&4032)>>>6,u[_++]=128|(N&63)>>>0):(u[_++]=240|(N&1835008)>>>18,u[_++]=128|(N&258048)>>>12,u[_++]=128|(N&4032)>>>6,u[_++]=128|(N&63)>>>0),_>=64&&(this._step(),_-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),_}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=v._bigBlock32,_=this._buffDV;for(let w=0;w<64;w+=4)u.setUint32(w,_.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)u.setUint32(w,S(u.getUint32(w-12,!1)^u.getUint32(w-32,!1)^u.getUint32(w-56,!1)^u.getUint32(w-64,!1),1),!1);let N=this._h0,n=this._h1,r=this._h2,l=this._h3,g=this._h4,C,b,L;for(let w=0;w<80;w++)w<20?(C=n&r|~n&l,b=1518500249):w<40?(C=n^r^l,b=1859775393):w<60?(C=n&r|n&l|r&l,b=2400959708):(C=n^r^l,b=3395469782),L=S(N,5)+C+g+b+u.getUint32(w*4,!1)&4294967295,g=l,l=r,r=S(n,30),n=N,N=L;this._h0=this._h0+N&4294967295,this._h1=this._h1+n&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+g&4294967295}}t.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),$(z[10],V([0,1,14,22]),function(I,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class p{constructor(c){this.source=c}getElements(){const c=this.source,h=new Int32Array(c.length);for(let m=0,v=c.length;m<v;m++)h[m]=c.charCodeAt(m);return h}}t.StringDiffSequence=p;function s(S,c,h){return new f(new p(S),new p(c)).ComputeDiff(h).changes}t.stringDiff=s;class d{static Assert(c,h){if(!c)throw new Error(h)}}t.Debug=d;class a{static Copy(c,h,m,v,i){for(let u=0;u<i;u++)m[v+u]=c[h+u]}static Copy2(c,h,m,v,i){for(let u=0;u<i;u++)m[v+u]=c[h+u]}}t.MyArray=a;class o{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(c,h){this.m_originalStart=Math.min(this.m_originalStart,c),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_originalCount++}AddModifiedElement(c,h){this.m_originalStart=Math.min(this.m_originalStart,c),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class f{constructor(c,h,m=null){this.ContinueProcessingPredicate=m,this._originalSequence=c,this._modifiedSequence=h;const[v,i,u]=f._getElements(c),[_,N,n]=f._getElements(h);this._hasStrings=u&&n,this._originalStringElements=v,this._originalElementsOrHash=i,this._modifiedStringElements=_,this._modifiedElementsOrHash=N,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(c){return c.length>0&&typeof c[0]=="string"}static _getElements(c){const h=c.getElements();if(f._isStringArray(h)){const m=new Int32Array(h.length);for(let v=0,i=h.length;v<i;v++)m[v]=(0,M.stringHash)(h[v],0);return[h,m,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}ElementsAreEqual(c,h){return this._originalElementsOrHash[c]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[c]===this._modifiedStringElements[h]:!0}ElementsAreStrictEqual(c,h){if(!this.ElementsAreEqual(c,h))return!1;const m=f._getStrictElement(this._originalSequence,c),v=f._getStrictElement(this._modifiedSequence,h);return m===v}static _getStrictElement(c,h){return typeof c.getStrictElement=="function"?c.getStrictElement(h):null}OriginalElementsAreEqual(c,h){return this._originalElementsOrHash[c]!==this._originalElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[c]===this._originalStringElements[h]:!0}ModifiedElementsAreEqual(c,h){return this._modifiedElementsOrHash[c]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._modifiedStringElements[c]===this._modifiedStringElements[h]:!0}ComputeDiff(c){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,c)}_ComputeDiff(c,h,m,v,i){const u=[!1];let _=this.ComputeDiffRecursive(c,h,m,v,u);return i&&(_=this.PrettifyChanges(_)),{quitEarly:u[0],changes:_}}ComputeDiffRecursive(c,h,m,v,i){for(i[0]=!1;c<=h&&m<=v&&this.ElementsAreEqual(c,m);)c++,m++;for(;h>=c&&v>=m&&this.ElementsAreEqual(h,v);)h--,v--;if(c>h||m>v){let l;return m<=v?(d.Assert(c===h+1,"originalStart should only be one more than originalEnd"),l=[new E.DiffChange(c,0,m,v-m+1)]):c<=h?(d.Assert(m===v+1,"modifiedStart should only be one more than modifiedEnd"),l=[new E.DiffChange(c,h-c+1,m,0)]):(d.Assert(c===h+1,"originalStart should only be one more than originalEnd"),d.Assert(m===v+1,"modifiedStart should only be one more than modifiedEnd"),l=[]),l}const u=[0],_=[0],N=this.ComputeRecursionPoint(c,h,m,v,u,_,i),n=u[0],r=_[0];if(N!==null)return N;if(!i[0]){const l=this.ComputeDiffRecursive(c,n,m,r,i);let g=[];return i[0]?g=[new E.DiffChange(n+1,h-(n+1)+1,r+1,v-(r+1)+1)]:g=this.ComputeDiffRecursive(n+1,h,r+1,v,i),this.ConcatenateChanges(l,g)}return[new E.DiffChange(c,h-c+1,m,v-m+1)]}WALKTRACE(c,h,m,v,i,u,_,N,n,r,l,g,C,b,L,w,y,P){let U=null,R=null,W=new o,Y=h,k=m,F=C[0]-w[0]-v,B=-1073741824,H=this.m_forwardHistory.length-1;do{const e=F+c;e===Y||e<k&&n[e-1]<n[e+1]?(l=n[e+1],b=l-F-v,l<B&&W.MarkNextChange(),B=l,W.AddModifiedElement(l+1,b),F=e+1-c):(l=n[e-1]+1,b=l-F-v,l<B&&W.MarkNextChange(),B=l-1,W.AddOriginalElement(l,b+1),F=e-1-c),H>=0&&(n=this.m_forwardHistory[H],c=n[0],Y=1,k=n.length-1)}while(--H>=-1);if(U=W.getReverseChanges(),P[0]){let e=C[0]+1,q=w[0]+1;if(U!==null&&U.length>0){const G=U[U.length-1];e=Math.max(e,G.getOriginalEnd()),q=Math.max(q,G.getModifiedEnd())}R=[new E.DiffChange(e,g-e+1,q,L-q+1)]}else{W=new o,Y=u,k=_,F=C[0]-w[0]-N,B=1073741824,H=y?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const e=F+i;e===Y||e<k&&r[e-1]>=r[e+1]?(l=r[e+1]-1,b=l-F-N,l>B&&W.MarkNextChange(),B=l+1,W.AddOriginalElement(l+1,b+1),F=e+1-i):(l=r[e-1],b=l-F-N,l>B&&W.MarkNextChange(),B=l,W.AddModifiedElement(l+1,b+1),F=e-1-i),H>=0&&(r=this.m_reverseHistory[H],i=r[0],Y=1,k=r.length-1)}while(--H>=-1);R=W.getChanges()}return this.ConcatenateChanges(U,R)}ComputeRecursionPoint(c,h,m,v,i,u,_){let N=0,n=0,r=0,l=0,g=0,C=0;c--,m--,i[0]=0,u[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const b=h-c+(v-m),L=b+1,w=new Int32Array(L),y=new Int32Array(L),P=v-m,U=h-c,R=c-m,W=h-v,k=(U-P)%2==0;w[P]=c,y[U]=h,_[0]=!1;for(let F=1;F<=b/2+1;F++){let B=0,H=0;r=this.ClipDiagonalBound(P-F,F,P,L),l=this.ClipDiagonalBound(P+F,F,P,L);for(let q=r;q<=l;q+=2){q===r||q<l&&w[q-1]<w[q+1]?N=w[q+1]:N=w[q-1]+1,n=N-(q-P)-R;const G=N;for(;N<h&&n<v&&this.ElementsAreEqual(N+1,n+1);)N++,n++;if(w[q]=N,N+n>B+H&&(B=N,H=n),!k&&Math.abs(q-U)<=F-1&&N>=y[q])return i[0]=N,u[0]=n,G<=y[q]&&1447>0&&F<=1447+1?this.WALKTRACE(P,r,l,R,U,g,C,W,w,y,N,h,i,n,v,u,k,_):null}const e=(B-c+(H-m)-F)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(B,e))return _[0]=!0,i[0]=B,u[0]=H,e>0&&1447>0&&F<=1447+1?this.WALKTRACE(P,r,l,R,U,g,C,W,w,y,N,h,i,n,v,u,k,_):(c++,m++,[new E.DiffChange(c,h-c+1,m,v-m+1)]);g=this.ClipDiagonalBound(U-F,F,U,L),C=this.ClipDiagonalBound(U+F,F,U,L);for(let q=g;q<=C;q+=2){q===g||q<C&&y[q-1]>=y[q+1]?N=y[q+1]-1:N=y[q-1],n=N-(q-U)-W;const G=N;for(;N>c&&n>m&&this.ElementsAreEqual(N,n);)N--,n--;if(y[q]=N,k&&Math.abs(q-P)<=F&&N<=w[q])return i[0]=N,u[0]=n,G>=w[q]&&1447>0&&F<=1447+1?this.WALKTRACE(P,r,l,R,U,g,C,W,w,y,N,h,i,n,v,u,k,_):null}if(F<=1447){let q=new Int32Array(l-r+2);q[0]=P-r+1,a.Copy2(w,r,q,1,l-r+1),this.m_forwardHistory.push(q),q=new Int32Array(C-g+2),q[0]=U-g+1,a.Copy2(y,g,q,1,C-g+1),this.m_reverseHistory.push(q)}}return this.WALKTRACE(P,r,l,R,U,g,C,W,w,y,N,h,i,n,v,u,k,_)}PrettifyChanges(c){for(let h=0;h<c.length;h++){const m=c[h],v=h<c.length-1?c[h+1].originalStart:this._originalElementsOrHash.length,i=h<c.length-1?c[h+1].modifiedStart:this._modifiedElementsOrHash.length,u=m.originalLength>0,_=m.modifiedLength>0;for(;m.originalStart+m.originalLength<v&&m.modifiedStart+m.modifiedLength<i&&(!u||this.OriginalElementsAreEqual(m.originalStart,m.originalStart+m.originalLength))&&(!_||this.ModifiedElementsAreEqual(m.modifiedStart,m.modifiedStart+m.modifiedLength));){const n=this.ElementsAreStrictEqual(m.originalStart,m.modifiedStart);if(this.ElementsAreStrictEqual(m.originalStart+m.originalLength,m.modifiedStart+m.modifiedLength)&&!n)break;m.originalStart++,m.modifiedStart++}let N=[null];if(h<c.length-1&&this.ChangesOverlap(c[h],c[h+1],N)){c[h]=N[0],c.splice(h+1,1),h--;continue}}for(let h=c.length-1;h>=0;h--){const m=c[h];let v=0,i=0;if(h>0){const l=c[h-1];v=l.originalStart+l.originalLength,i=l.modifiedStart+l.modifiedLength}const u=m.originalLength>0,_=m.modifiedLength>0;let N=0,n=this._boundaryScore(m.originalStart,m.originalLength,m.modifiedStart,m.modifiedLength);for(let l=1;;l++){const g=m.originalStart-l,C=m.modifiedStart-l;if(g<v||C<i||u&&!this.OriginalElementsAreEqual(g,g+m.originalLength)||_&&!this.ModifiedElementsAreEqual(C,C+m.modifiedLength))break;const L=(g===v&&C===i?5:0)+this._boundaryScore(g,m.originalLength,C,m.modifiedLength);L>n&&(n=L,N=l)}m.originalStart-=N,m.modifiedStart-=N;const r=[null];if(h>0&&this.ChangesOverlap(c[h-1],c[h],r)){c[h-1]=r[0],c.splice(h,1),h++;continue}}if(this._hasStrings)for(let h=1,m=c.length;h<m;h++){const v=c[h-1],i=c[h],u=i.originalStart-v.originalStart-v.originalLength,_=v.originalStart,N=i.originalStart+i.originalLength,n=N-_,r=v.modifiedStart,l=i.modifiedStart+i.modifiedLength,g=l-r;if(u<5&&n<20&&g<20){const C=this._findBetterContiguousSequence(_,n,r,g,u);if(C){const[b,L]=C;(b!==v.originalStart+v.originalLength||L!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=b-v.originalStart,v.modifiedLength=L-v.modifiedStart,i.originalStart=b+u,i.modifiedStart=L+u,i.originalLength=N-i.originalStart,i.modifiedLength=l-i.modifiedStart)}}}return c}_findBetterContiguousSequence(c,h,m,v,i){if(h<i||v<i)return null;const u=c+h-i+1,_=m+v-i+1;let N=0,n=0,r=0;for(let l=c;l<u;l++)for(let g=m;g<_;g++){const C=this._contiguousSequenceScore(l,g,i);C>0&&C>N&&(N=C,n=l,r=g)}return N>0?[n,r]:null}_contiguousSequenceScore(c,h,m){let v=0;for(let i=0;i<m;i++){if(!this.ElementsAreEqual(c+i,h+i))return 0;v+=this._originalStringElements[c+i].length}return v}_OriginalIsBoundary(c){return c<=0||c>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[c])}_OriginalRegionIsBoundary(c,h){if(this._OriginalIsBoundary(c)||this._OriginalIsBoundary(c-1))return!0;if(h>0){const m=c+h;if(this._OriginalIsBoundary(m-1)||this._OriginalIsBoundary(m))return!0}return!1}_ModifiedIsBoundary(c){return c<=0||c>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[c])}_ModifiedRegionIsBoundary(c,h){if(this._ModifiedIsBoundary(c)||this._ModifiedIsBoundary(c-1))return!0;if(h>0){const m=c+h;if(this._ModifiedIsBoundary(m-1)||this._ModifiedIsBoundary(m))return!0}return!1}_boundaryScore(c,h,m,v){const i=this._OriginalRegionIsBoundary(c,h)?1:0,u=this._ModifiedRegionIsBoundary(m,v)?1:0;return i+u}ConcatenateChanges(c,h){let m=[];if(c.length===0||h.length===0)return h.length>0?h:c;if(this.ChangesOverlap(c[c.length-1],h[0],m)){const v=new Array(c.length+h.length-1);return a.Copy(c,0,v,0,c.length-1),v[c.length-1]=m[0],a.Copy(h,1,v,c.length,h.length-1),v}else{const v=new Array(c.length+h.length);return a.Copy(c,0,v,0,c.length),a.Copy(h,0,v,c.length,h.length),v}}ChangesOverlap(c,h,m){if(d.Assert(c.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),d.Assert(c.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=h.originalStart||c.modifiedStart+c.modifiedLength>=h.modifiedStart){const v=c.originalStart;let i=c.originalLength;const u=c.modifiedStart;let _=c.modifiedLength;return c.originalStart+c.originalLength>=h.originalStart&&(i=h.originalStart+h.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=h.modifiedStart&&(_=h.modifiedStart+h.modifiedLength-c.modifiedStart),m[0]=new E.DiffChange(v,i,u,_),!0}else return m[0]=null,!1}ClipDiagonalBound(c,h,m,v){if(c>=0&&c<v)return c;const i=m,u=v-m-1,_=h%2==0;if(c<0){const N=i%2==0;return _===N?0:1}else{const N=u%2==0;return _===N?v-1:v-2}}}t.LcsDiff=f}),$(z[11],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.isFunction=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isString=t.isArray=void 0;function E(n){return Array.isArray(n)}t.isArray=E;function M(n){return typeof n=="string"}t.isString=M;function p(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}t.isObject=p;function s(n){return typeof n=="number"&&!isNaN(n)}t.isNumber=s;function d(n){return n===!0||n===!1}t.isBoolean=d;function a(n){return typeof n=="undefined"}t.isUndefined=a;function o(n){return a(n)||n===null}t.isUndefinedOrNull=o;function f(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}t.assertType=f;function S(n){if(o(n))throw new Error("Assertion Failed: argument is undefined or null");return n}t.assertIsDefined=S;function c(n){return typeof n=="function"}t.isFunction=c;function h(n,r){const l=Math.min(n.length,r.length);for(let g=0;g<l;g++)m(n[g],r[g])}t.validateConstraints=h;function m(n,r){if(M(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(c(r)){try{if(n instanceof r)return}catch(l){}if(!o(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=m;function v(n){let r=[],l=Object.getPrototypeOf(n);for(;Object.prototype!==l;)r=r.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return r}t.getAllPropertyNames=v;function i(n){const r=[];for(const l of v(n))typeof n[l]=="function"&&r.push(l);return r}t.getAllMethodNames=i;function u(n,r){const l=C=>function(){const b=Array.prototype.slice.call(arguments,0);return r(C,b)};let g={};for(const C of n)g[C]=l(C);return g}t.createProxyObject=u;function _(n){return n===null?void 0:n}t.withNullAsUndefined=_;function N(n,r="Unreachable"){throw new Error(r)}t.assertNever=N}),$(z[12],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=void 0;function E(p){return p<0?0:p>255?255:p|0}t.toUint8=E;function M(p){return p<0?0:p>4294967295?4294967295:p|0}t.toUint32=M}),$(z[13],V([0,1,20,2]),function(I,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const p=/^\w[\w\d+.-]*$/,s=/^\//,d=/^\/\//;function a(b,L){if(!b.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${b.authority}", path: "${b.path}", query: "${b.query}", fragment: "${b.fragment}"}`);if(b.scheme&&!p.test(b.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(b.path){if(b.authority){if(!s.test(b.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(b.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(b,L){return!b&&!L?"file":b}function f(b,L){switch(b){case"https":case"http":case"file":L?L[0]!==c&&(L=c+L):L=c;break}return L}const S="",c="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(L,w,y,P,U,R=!1){typeof L=="object"?(this.scheme=L.scheme||S,this.authority=L.authority||S,this.path=L.path||S,this.query=L.query||S,this.fragment=L.fragment||S):(this.scheme=o(L,R),this.authority=w||S,this.path=f(this.scheme,y||S),this.query=P||S,this.fragment=U||S,a(this,R))}static isUri(L){return L instanceof m?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}get fsPath(){return n(this,!1)}with(L){if(!L)return this;let{scheme:w,authority:y,path:P,query:U,fragment:R}=L;return w===void 0?w=this.scheme:w===null&&(w=S),y===void 0?y=this.authority:y===null&&(y=S),P===void 0?P=this.path:P===null&&(P=S),U===void 0?U=this.query:U===null&&(U=S),R===void 0?R=this.fragment:R===null&&(R=S),w===this.scheme&&y===this.authority&&P===this.path&&U===this.query&&R===this.fragment?this:new i(w,y,P,U,R)}static parse(L,w=!1){const y=h.exec(L);return y?new i(y[2]||S,C(y[4]||S),C(y[5]||S),C(y[7]||S),C(y[9]||S),w):new i(S,S,S,S,S)}static file(L){let w=S;if(M.isWindows&&(L=L.replace(/\\/g,c)),L[0]===c&&L[1]===c){const y=L.indexOf(c,2);y===-1?(w=L.substring(2),L=c):(w=L.substring(2,y),L=L.substring(y)||c)}return new i("file",w,L,S,S)}static from(L){const w=new i(L.scheme,L.authority,L.path,L.query,L.fragment);return a(w,!0),w}static joinPath(L,...w){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return M.isWindows&&L.scheme==="file"?y=m.file(E.win32.join(n(L,!0),...w)).path:y=E.posix.join(L.path,...w),L.with({path:y})}toString(L=!1){return r(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof m)return L;{const w=new i(L);return w._formatted=L.external,w._fsPath=L._sep===v?L.fsPath:null,w}}else return L}}t.URI=m;const v=M.isWindows?1:void 0;class i extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(L=!1){return L?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=v),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(b,L){let w,y=-1;for(let P=0;P<b.length;P++){const U=b.charCodeAt(P);if(U>=97&&U<=122||U>=65&&U<=90||U>=48&&U<=57||U===45||U===46||U===95||U===126||L&&U===47)y!==-1&&(w+=encodeURIComponent(b.substring(y,P)),y=-1),w!==void 0&&(w+=b.charAt(P));else{w===void 0&&(w=b.substr(0,P));const R=u[U];R!==void 0?(y!==-1&&(w+=encodeURIComponent(b.substring(y,P)),y=-1),w+=R):y===-1&&(y=P)}}return y!==-1&&(w+=encodeURIComponent(b.substring(y))),w!==void 0?w:b}function N(b){let L;for(let w=0;w<b.length;w++){const y=b.charCodeAt(w);y===35||y===63?(L===void 0&&(L=b.substr(0,w)),L+=u[y]):L!==void 0&&(L+=b[w])}return L!==void 0?L:b}function n(b,L){let w;return b.authority&&b.path.length>1&&b.scheme==="file"?w=`//${b.authority}${b.path}`:b.path.charCodeAt(0)===47&&(b.path.charCodeAt(1)>=65&&b.path.charCodeAt(1)<=90||b.path.charCodeAt(1)>=97&&b.path.charCodeAt(1)<=122)&&b.path.charCodeAt(2)===58?L?w=b.path.substr(1):w=b.path[1].toLowerCase()+b.path.substr(2):w=b.path,M.isWindows&&(w=w.replace(/\//g,"\\")),w}t.uriToFsPath=n;function r(b,L){const w=L?N:_;let y="",{scheme:P,authority:U,path:R,query:W,fragment:Y}=b;if(P&&(y+=P,y+=":"),(U||P==="file")&&(y+=c,y+=c),U){let k=U.indexOf("@");if(k!==-1){const F=U.substr(0,k);U=U.substr(k+1),k=F.indexOf(":"),k===-1?y+=w(F,!1):(y+=w(F.substr(0,k),!1),y+=":",y+=w(F.substr(k+1),!1)),y+="@"}U=U.toLowerCase(),k=U.indexOf(":"),k===-1?y+=w(U,!1):(y+=w(U.substr(0,k),!1),y+=U.substr(k))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const k=R.charCodeAt(1);k>=65&&k<=90&&(R=`/${String.fromCharCode(k+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const k=R.charCodeAt(0);k>=65&&k<=90&&(R=`${String.fromCharCode(k+32)}:${R.substr(2)}`)}y+=w(R,!0)}return W&&(y+="?",y+=w(W,!1)),Y&&(y+="#",y+=L?Y:_(Y,!1)),y}function l(b){try{return decodeURIComponent(b)}catch(L){return b.length>3?b.substr(0,3)+l(b.substr(3)):b}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function C(b){return b.match(g)?b.replace(g,L=>l(L)):b}}),$(z[34],V([0,1,4,7,2,11]),function(I,t,E,M,p,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const d="$initialize";let a=!1;function o(m){!p.isWeb||(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(m.message))}t.logOnceWebWorkerWarning=o;class f{constructor(v){this._workerId=-1,this._handler=v,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(v){this._workerId=v}sendMessage(v,i){let u=String(++this._lastSentReq);return new Promise((_,N)=>{this._pendingReplies[u]={resolve:_,reject:N},this._send({vsWorker:this._workerId,req:u,method:v,args:i})})}handleMessage(v){!v||!v.vsWorker||this._workerId!==-1&&v.vsWorker!==this._workerId||this._handleMessage(v)}_handleMessage(v){if(v.seq){let N=v;if(!this._pendingReplies[N.seq]){console.warn("Got reply to unknown seq");return}let n=this._pendingReplies[N.seq];if(delete this._pendingReplies[N.seq],N.err){let r=N.err;N.err.$isError&&(r=new Error,r.name=N.err.name,r.message=N.err.message,r.stack=N.err.stack),n.reject(r);return}n.resolve(N.res);return}let i=v,u=i.req;this._handler.handleMessage(i.method,i.args).then(N=>{this._send({vsWorker:this._workerId,seq:u,res:N,err:void 0})},N=>{N.detail instanceof Error&&(N.detail=(0,E.transformErrorForSerialization)(N.detail)),this._send({vsWorker:this._workerId,seq:u,res:void 0,err:(0,E.transformErrorForSerialization)(N)})})}_send(v){let i=[];if(v.req){const u=v;for(let _=0;_<u.args.length;_++)u.args[_]instanceof ArrayBuffer&&i.push(u.args[_])}else{const u=v;u.res instanceof ArrayBuffer&&i.push(u.res)}this._handler.sendMessage(v,i)}}class S extends M.Disposable{constructor(v,i,u){super();let _=null;this._worker=this._register(v.create("vs/base/common/worker/simpleWorker",l=>{this._protocol.handleMessage(l)},l=>{_&&_(l)})),this._protocol=new f({sendMessage:(l,g)=>{this._worker.postMessage(l,g)},handleMessage:(l,g)=>{if(typeof u[l]!="function")return Promise.reject(new Error("Missing method "+l+" on main thread host."));try{return Promise.resolve(u[l].apply(u,g))}catch(C){return Promise.reject(C)}}}),this._protocol.setWorkerId(this._worker.getId());let N=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?N=self.require.getConfig():typeof self.requirejs!="undefined"&&(N=self.requirejs.s.contexts._.config);const n=s.getAllMethodNames(u);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(N)),i,n]);const r=(l,g)=>this._request(l,g);this._lazyProxy=new Promise((l,g)=>{_=g,this._onModuleLoaded.then(C=>{l(s.createProxyObject(C,r))},C=>{g(C),this._onError("Worker failed to load "+i,C)})})}getProxyObject(){return this._lazyProxy}_request(v,i){return new Promise((u,_)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(v,i).then(u,_)},_)})}_onError(v,i){console.error(v),console.info(i)}}t.SimpleWorkerClient=S;class c{constructor(v,i){this._requestHandlerFactory=i,this._requestHandler=null,this._protocol=new f({sendMessage:(u,_)=>{v(u,_)},handleMessage:(u,_)=>this._handleMessage(u,_)})}onmessage(v){this._protocol.handleMessage(v)}_handleMessage(v,i){if(v===d)return this.initialize(i[0],i[1],i[2],i[3]);if(!this._requestHandler||typeof this._requestHandler[v]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+v));try{return Promise.resolve(this._requestHandler[v].apply(this._requestHandler,i))}catch(u){return Promise.reject(u)}}initialize(v,i,u,_){this._protocol.setWorkerId(v);const N=(r,l)=>this._protocol.sendMessage(r,l),n=s.createProxyObject(_,N);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(n),Promise.resolve(s.getAllMethodNames(this._requestHandler))):(i&&(typeof i.baseUrl!="undefined"&&delete i.baseUrl,typeof i.paths!="undefined"&&typeof i.paths.vs!="undefined"&&delete i.paths.vs,typeof i.trustedTypesPolicy!==void 0&&delete i.trustedTypesPolicy,i.catchError=!0,self.require.config(i)),new Promise((r,l)=>{self.require([u],g=>{if(this._requestHandler=g.create(n),!this._requestHandler){l(new Error("No RequestHandler!"));return}r(s.getAllMethodNames(this._requestHandler))},l)}))}}t.SimpleWorkerServer=c;function h(m){return new c(m,null)}t.create=h}),$(z[23],V([0,1,12]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class M{constructor(d){let a=(0,E.toUint8)(d);this._defaultValue=a,this._asciiMap=M._createAsciiMap(a),this._map=new Map}static _createAsciiMap(d){let a=new Uint8Array(256);for(let o=0;o<256;o++)a[o]=d;return a}set(d,a){let o=(0,E.toUint8)(a);d>=0&&d<256?this._asciiMap[d]=o:this._map.set(d,o)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}}t.CharacterClassifier=M;class p{constructor(){this._actual=new M(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}}t.CharacterSet=p}),$(z[3],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class E{constructor(p,s){this.lineNumber=p,this.column=s}with(p=this.lineNumber,s=this.column){return p===this.lineNumber&&s===this.column?this:new E(p,s)}delta(p=0,s=0){return this.with(this.lineNumber+p,this.column+s)}equals(p){return E.equals(this,p)}static equals(p,s){return!p&&!s?!0:!!p&&!!s&&p.lineNumber===s.lineNumber&&p.column===s.column}isBefore(p){return E.isBefore(this,p)}static isBefore(p,s){return p.lineNumber<s.lineNumber?!0:s.lineNumber<p.lineNumber?!1:p.column<s.column}isBeforeOrEqual(p){return E.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,s){return p.lineNumber<s.lineNumber?!0:s.lineNumber<p.lineNumber?!1:p.column<=s.column}static compare(p,s){let d=p.lineNumber|0,a=s.lineNumber|0;if(d===a){let o=p.column|0,f=s.column|0;return o-f}return d-a}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new E(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}}t.Position=E}),$(z[6],V([0,1,3]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class M{constructor(s,d,a,o){s>a||s===a&&d>o?(this.startLineNumber=a,this.startColumn=o,this.endLineNumber=s,this.endColumn=d):(this.startLineNumber=s,this.startColumn=d,this.endLineNumber=a,this.endColumn=o)}isEmpty(){return M.isEmpty(this)}static isEmpty(s){return s.startLineNumber===s.endLineNumber&&s.startColumn===s.endColumn}containsPosition(s){return M.containsPosition(this,s)}static containsPosition(s,d){return!(d.lineNumber<s.startLineNumber||d.lineNumber>s.endLineNumber||d.lineNumber===s.startLineNumber&&d.column<s.startColumn||d.lineNumber===s.endLineNumber&&d.column>s.endColumn)}containsRange(s){return M.containsRange(this,s)}static containsRange(s,d){return!(d.startLineNumber<s.startLineNumber||d.endLineNumber<s.startLineNumber||d.startLineNumber>s.endLineNumber||d.endLineNumber>s.endLineNumber||d.startLineNumber===s.startLineNumber&&d.startColumn<s.startColumn||d.endLineNumber===s.endLineNumber&&d.endColumn>s.endColumn)}strictContainsRange(s){return M.strictContainsRange(this,s)}static strictContainsRange(s,d){return!(d.startLineNumber<s.startLineNumber||d.endLineNumber<s.startLineNumber||d.startLineNumber>s.endLineNumber||d.endLineNumber>s.endLineNumber||d.startLineNumber===s.startLineNumber&&d.startColumn<=s.startColumn||d.endLineNumber===s.endLineNumber&&d.endColumn>=s.endColumn)}plusRange(s){return M.plusRange(this,s)}static plusRange(s,d){let a,o,f,S;return d.startLineNumber<s.startLineNumber?(a=d.startLineNumber,o=d.startColumn):d.startLineNumber===s.startLineNumber?(a=d.startLineNumber,o=Math.min(d.startColumn,s.startColumn)):(a=s.startLineNumber,o=s.startColumn),d.endLineNumber>s.endLineNumber?(f=d.endLineNumber,S=d.endColumn):d.endLineNumber===s.endLineNumber?(f=d.endLineNumber,S=Math.max(d.endColumn,s.endColumn)):(f=s.endLineNumber,S=s.endColumn),new M(a,o,f,S)}intersectRanges(s){return M.intersectRanges(this,s)}static intersectRanges(s,d){let a=s.startLineNumber,o=s.startColumn,f=s.endLineNumber,S=s.endColumn,c=d.startLineNumber,h=d.startColumn,m=d.endLineNumber,v=d.endColumn;return a<c?(a=c,o=h):a===c&&(o=Math.max(o,h)),f>m?(f=m,S=v):f===m&&(S=Math.min(S,v)),a>f||a===f&&o>S?null:new M(a,o,f,S)}equalsRange(s){return M.equalsRange(this,s)}static equalsRange(s,d){return!!s&&!!d&&s.startLineNumber===d.startLineNumber&&s.startColumn===d.startColumn&&s.endLineNumber===d.endLineNumber&&s.endColumn===d.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(s){return new E.Position(s.endLineNumber,s.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(s){return new E.Position(s.startLineNumber,s.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(s,d){return new M(this.startLineNumber,this.startColumn,s,d)}setStartPosition(s,d){return new M(s,d,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(s){return new M(s.startLineNumber,s.startColumn,s.startLineNumber,s.startColumn)}static fromPositions(s,d=s){return new M(s.lineNumber,s.column,d.lineNumber,d.column)}static lift(s){return s?new M(s.startLineNumber,s.startColumn,s.endLineNumber,s.endColumn):null}static isIRange(s){return s&&typeof s.startLineNumber=="number"&&typeof s.startColumn=="number"&&typeof s.endLineNumber=="number"&&typeof s.endColumn=="number"}static areIntersectingOrTouching(s,d){return!(s.endLineNumber<d.startLineNumber||s.endLineNumber===d.startLineNumber&&s.endColumn<d.startColumn||d.endLineNumber<s.startLineNumber||d.endLineNumber===s.startLineNumber&&d.endColumn<s.startColumn)}static areIntersecting(s,d){return!(s.endLineNumber<d.startLineNumber||s.endLineNumber===d.startLineNumber&&s.endColumn<=d.startColumn||d.endLineNumber<s.startLineNumber||d.endLineNumber===s.startLineNumber&&d.endColumn<=s.startColumn)}static compareRangesUsingStarts(s,d){if(s&&d){const f=s.startLineNumber|0,S=d.startLineNumber|0;if(f===S){const c=s.startColumn|0,h=d.startColumn|0;if(c===h){const m=s.endLineNumber|0,v=d.endLineNumber|0;if(m===v){const i=s.endColumn|0,u=d.endColumn|0;return i-u}return m-v}return c-h}return f-S}return(s?1:0)-(d?1:0)}static compareRangesUsingEnds(s,d){return s.endLineNumber===d.endLineNumber?s.endColumn===d.endColumn?s.startLineNumber===d.startLineNumber?s.startColumn-d.startColumn:s.startLineNumber-d.startLineNumber:s.endColumn-d.endColumn:s.endLineNumber-d.endLineNumber}static spansMultipleLines(s){return s.endLineNumber>s.startLineNumber}}t.Range=M}),$(z[24],V([0,1,3,6]),function(I,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;class p extends M.Range{constructor(d,a,o,f){super(d,a,o,f);this.selectionStartLineNumber=d,this.selectionStartColumn=a,this.positionLineNumber=o,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return p.selectionsEqual(this,d)}static selectionsEqual(d,a){return d.selectionStartLineNumber===a.selectionStartLineNumber&&d.selectionStartColumn===a.selectionStartColumn&&d.positionLineNumber===a.positionLineNumber&&d.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,a){return this.getDirection()===0?new p(this.startLineNumber,this.startColumn,d,a):new p(d,a,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(d,a){return this.getDirection()===0?new p(d,a,this.endLineNumber,this.endColumn):new p(this.endLineNumber,this.endColumn,d,a)}static fromPositions(d,a=d){return new p(d.lineNumber,d.column,a.lineNumber,a.column)}static liftSelection(d){return new p(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,a){if(d&&!a||!d&&a)return!1;if(!d&&!a)return!0;if(d.length!==a.length)return!1;for(let o=0,f=d.length;o<f;o++)if(!this.selectionsEqual(d[o],a[o]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,a,o,f,S){return S===0?new p(d,a,o,f):new p(o,f,d,a)}}t.Selection=p}),$(z[25],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class E{constructor(d,a,o){this._tokenBrand=void 0,this.offset=d|0,this.type=a,this.language=o}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=E;class M{constructor(d,a){this._tokenizationResultBrand=void 0,this.tokens=d,this.endState=a}}t.TokenizationResult=M;class p{constructor(d,a){this._tokenizationResult2Brand=void 0,this.tokens=d,this.endState=a}}t.TokenizationResult2=p}),$(z[26],V([0,1,10,5]),function(I,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const p=3;function s(i,u,_,N){return new E.LcsDiff(i,u,_).ComputeDiff(N)}class d{constructor(u){const _=[],N=[];for(let n=0,r=u.length;n<r;n++)_[n]=h(u[n],1),N[n]=m(u[n],1);this.lines=u,this._startColumns=_,this._endColumns=N}getElements(){const u=[];for(let _=0,N=this.lines.length;_<N;_++)u[_]=this.lines[_].substring(this._startColumns[_]-1,this._endColumns[_]-1);return u}getStrictElement(u){return this.lines[u]}getStartLineNumber(u){return u+1}getEndLineNumber(u){return u+1}createCharSequence(u,_,N){const n=[],r=[],l=[];let g=0;for(let C=_;C<=N;C++){const b=this.lines[C],L=u?this._startColumns[C]:1,w=u?this._endColumns[C]:b.length+1;for(let y=L;y<w;y++)n[g]=b.charCodeAt(y-1),r[g]=C+1,l[g]=y,g++}return new a(n,r,l)}}class a{constructor(u,_,N){this._charCodes=u,this._lineNumbers=_,this._columns=N}getElements(){return this._charCodes}getStartLineNumber(u){return this._lineNumbers[u]}getStartColumn(u){return this._columns[u]}getEndLineNumber(u){return this._lineNumbers[u]}getEndColumn(u){return this._columns[u]+1}}class o{constructor(u,_,N,n,r,l,g,C){this.originalStartLineNumber=u,this.originalStartColumn=_,this.originalEndLineNumber=N,this.originalEndColumn=n,this.modifiedStartLineNumber=r,this.modifiedStartColumn=l,this.modifiedEndLineNumber=g,this.modifiedEndColumn=C}static createFromDiffChange(u,_,N){let n,r,l,g,C,b,L,w;return u.originalLength===0?(n=0,r=0,l=0,g=0):(n=_.getStartLineNumber(u.originalStart),r=_.getStartColumn(u.originalStart),l=_.getEndLineNumber(u.originalStart+u.originalLength-1),g=_.getEndColumn(u.originalStart+u.originalLength-1)),u.modifiedLength===0?(C=0,b=0,L=0,w=0):(C=N.getStartLineNumber(u.modifiedStart),b=N.getStartColumn(u.modifiedStart),L=N.getEndLineNumber(u.modifiedStart+u.modifiedLength-1),w=N.getEndColumn(u.modifiedStart+u.modifiedLength-1)),new o(n,r,l,g,C,b,L,w)}}function f(i){if(i.length<=1)return i;const u=[i[0]];let _=u[0];for(let N=1,n=i.length;N<n;N++){const r=i[N],l=r.originalStart-(_.originalStart+_.originalLength),g=r.modifiedStart-(_.modifiedStart+_.modifiedLength);Math.min(l,g)<p?(_.originalLength=r.originalStart+r.originalLength-_.originalStart,_.modifiedLength=r.modifiedStart+r.modifiedLength-_.modifiedStart):(u.push(r),_=r)}return u}class S{constructor(u,_,N,n,r){this.originalStartLineNumber=u,this.originalEndLineNumber=_,this.modifiedStartLineNumber=N,this.modifiedEndLineNumber=n,this.charChanges=r}static createFromDiffResult(u,_,N,n,r,l,g){let C,b,L,w,y;if(_.originalLength===0?(C=N.getStartLineNumber(_.originalStart)-1,b=0):(C=N.getStartLineNumber(_.originalStart),b=N.getEndLineNumber(_.originalStart+_.originalLength-1)),_.modifiedLength===0?(L=n.getStartLineNumber(_.modifiedStart)-1,w=0):(L=n.getStartLineNumber(_.modifiedStart),w=n.getEndLineNumber(_.modifiedStart+_.modifiedLength-1)),l&&_.originalLength>0&&_.originalLength<20&&_.modifiedLength>0&&_.modifiedLength<20&&r()){const P=N.createCharSequence(u,_.originalStart,_.originalStart+_.originalLength-1),U=n.createCharSequence(u,_.modifiedStart,_.modifiedStart+_.modifiedLength-1);let R=s(P,U,r,!0).changes;g&&(R=f(R)),y=[];for(let W=0,Y=R.length;W<Y;W++)y.push(o.createFromDiffChange(R[W],P,U))}return new S(C,b,L,w,y)}}class c{constructor(u,_,N){this.shouldComputeCharChanges=N.shouldComputeCharChanges,this.shouldPostProcessCharChanges=N.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=N.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=N.shouldMakePrettyDiff,this.originalLines=u,this.modifiedLines=_,this.original=new d(u),this.modified=new d(_),this.continueLineDiff=v(N.maxComputationTime),this.continueCharDiff=v(N.maxComputationTime===0?0:Math.min(N.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const u=s(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),_=u.changes,N=u.quitEarly;if(this.shouldIgnoreTrimWhitespace){const g=[];for(let C=0,b=_.length;C<b;C++)g.push(S.createFromDiffResult(this.shouldIgnoreTrimWhitespace,_[C],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:N,changes:g}}const n=[];let r=0,l=0;for(let g=-1,C=_.length;g<C;g++){const b=g+1<C?_[g+1]:null,L=b?b.originalStart:this.originalLines.length,w=b?b.modifiedStart:this.modifiedLines.length;for(;r<L&&l<w;){const y=this.originalLines[r],P=this.modifiedLines[l];if(y!==P){{let U=h(y,1),R=h(P,1);for(;U>1&&R>1;){const W=y.charCodeAt(U-2),Y=P.charCodeAt(R-2);if(W!==Y)break;U--,R--}(U>1||R>1)&&this._pushTrimWhitespaceCharChange(n,r+1,1,U,l+1,1,R)}{let U=m(y,1),R=m(P,1);const W=y.length+1,Y=P.length+1;for(;U<W&&R<Y;){const k=y.charCodeAt(U-1),F=y.charCodeAt(R-1);if(k!==F)break;U++,R++}(U<W||R<Y)&&this._pushTrimWhitespaceCharChange(n,r+1,U,W,l+1,R,Y)}}r++,l++}b&&(n.push(S.createFromDiffResult(this.shouldIgnoreTrimWhitespace,b,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=b.originalLength,l+=b.modifiedLength)}return{quitEarly:N,changes:n}}_pushTrimWhitespaceCharChange(u,_,N,n,r,l,g){if(this._mergeTrimWhitespaceCharChange(u,_,N,n,r,l,g))return;let C;this.shouldComputeCharChanges&&(C=[new o(_,N,_,n,r,l,r,g)]),u.push(new S(_,_,r,r,C))}_mergeTrimWhitespaceCharChange(u,_,N,n,r,l,g){const C=u.length;if(C===0)return!1;const b=u[C-1];return b.originalEndLineNumber===0||b.modifiedEndLineNumber===0?!1:b.originalEndLineNumber+1===_&&b.modifiedEndLineNumber+1===r?(b.originalEndLineNumber=_,b.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&b.charChanges&&b.charChanges.push(new o(_,N,_,n,r,l,r,g)),!0):!1}}t.DiffComputer=c;function h(i,u){const _=M.firstNonWhitespaceIndex(i);return _===-1?u:_+1}function m(i,u){const _=M.lastNonWhitespaceIndex(i);return _===-1?u:_+2}function v(i){if(i===0)return()=>!0;const u=Date.now();return()=>Date.now()-u<i}}),$(z[27],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(a=""){let o="(-?\\d*\\.\\d\\w*)|([^";for(const f of t.USUAL_WORD_SEPARATORS)a.indexOf(f)>=0||(o+="\\"+f);return o+="\\s]+)",new RegExp(o,"g")}t.DEFAULT_WORD_REGEXP=E();function M(a){let o=t.DEFAULT_WORD_REGEXP;if(a&&a instanceof RegExp)if(a.global)o=a;else{let f="g";a.ignoreCase&&(f+="i"),a.multiline&&(f+="m"),a.unicode&&(f+="u"),o=new RegExp(a.source,f)}return o.lastIndex=0,o}t.ensureValidWordDefinition=M;const p={maxLen:1e3,windowSize:15,timeBudget:150};function s(a,o,f,S,c=p){if(f.length>c.maxLen){let u=a-c.maxLen/2;return u<0?u=0:S+=u,f=f.substring(u,a+c.maxLen/2),s(a,o,f,S,c)}const h=Date.now(),m=a-1-S;let v=-1,i=null;for(let u=1;!(Date.now()-h>=c.timeBudget);u++){const _=m-c.windowSize*u;o.lastIndex=Math.max(0,_);const N=d(o,f,m,v);if(!N&&i||(i=N,_<=0))break;v=_}if(i){let u={word:i[0],startColumn:S+1+i.index,endColumn:S+1+i.index+i[0].length};return o.lastIndex=0,u}return null}t.getWordAtText=s;function d(a,o,f,S){let c;for(;c=a.exec(o);){const h=c.index||0;if(h<=f&&a.lastIndex>=f)return c;if(S>0&&h>S)return null}return null}}),$(z[28],V([0,1,23]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=void 0;class M{constructor(h,m,v){const i=new Uint8Array(h*m);for(let u=0,_=h*m;u<_;u++)i[u]=v;this._data=i,this.rows=h,this.cols=m}get(h,m){return this._data[h*this.cols+m]}set(h,m,v){this._data[h*this.cols+m]=v}}t.Uint8Matrix=M;class p{constructor(h){let m=0,v=0;for(let u=0,_=h.length;u<_;u++){let[N,n,r]=h[u];n>m&&(m=n),N>v&&(v=N),r>v&&(v=r)}m++,v++;let i=new M(v,m,0);for(let u=0,_=h.length;u<_;u++){let[N,n,r]=h[u];i.set(N,n,r)}this._states=i,this._maxCharCode=m}nextState(h,m){return m<0||m>=this._maxCharCode?0:this._states.get(h,m)}}t.StateMachine=p;let s=null;function d(){return s===null&&(s=new p([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),s}let a=null;function o(){if(a===null){a=new E.CharacterClassifier(0);const c=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<c.length;m++)a.set(c.charCodeAt(m),1);const h=".,;";for(let m=0;m<h.length;m++)a.set(h.charCodeAt(m),2)}return a}class f{static _createLink(h,m,v,i,u){let _=u-1;do{const N=m.charCodeAt(_);if(h.get(N)!==2)break;_--}while(_>i);if(i>0){const N=m.charCodeAt(i-1),n=m.charCodeAt(_);(N===40&&n===41||N===91&&n===93||N===123&&n===125)&&_--}return{range:{startLineNumber:v,startColumn:i+1,endLineNumber:v,endColumn:_+2},url:m.substring(i,_+1)}}static computeLinks(h,m=d()){const v=o();let i=[];for(let u=1,_=h.getLineCount();u<=_;u++){const N=h.getLineContent(u),n=N.length;let r=0,l=0,g=0,C=1,b=!1,L=!1,w=!1,y=!1;for(;r<n;){let P=!1;const U=N.charCodeAt(r);if(C===13){let R;switch(U){case 40:b=!0,R=0;break;case 41:R=b?0:1;break;case 91:w=!0,L=!0,R=0;break;case 93:w=!1,R=L?0:1;break;case 123:y=!0,R=0;break;case 125:R=y?0:1;break;case 39:R=g===34||g===96?0:1;break;case 34:R=g===39||g===96?0:1;break;case 96:R=g===39||g===34?0:1;break;case 42:R=g===42?1:0;break;case 124:R=g===124?1:0;break;case 32:R=w?0:1;break;default:R=v.get(U)}R===1&&(i.push(f._createLink(v,N,u,l,r)),P=!0)}else if(C===12){let R;U===91?(L=!0,R=0):R=v.get(U),R===1?P=!0:C=13}else C=m.nextState(C,U),C===0&&(P=!0);P&&(C=1,b=!1,L=!1,y=!1,l=r+1,g=U),r++}C===13&&i.push(f._createLink(v,N,u,l,n))}return i}}t.LinkComputer=f;function S(c){return!c||typeof c.getLineCount!="function"||typeof c.getLineContent!="function"?[]:f.computeLinks(c)}t.computeLinks=S}),$(z[29],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(p,s,d,a,o){if(p&&s){let f=this.doNavigateValueSet(s,o);if(f)return{range:p,value:f}}if(d&&a){let f=this.doNavigateValueSet(a,o);if(f)return{range:d,value:f}}return null}doNavigateValueSet(p,s){let d=this.numberReplace(p,s);return d!==null?d:this.textReplace(p,s)}numberReplace(p,s){let d=Math.pow(10,p.length-(p.lastIndexOf(".")+1)),a=Number(p),o=parseFloat(p);return!isNaN(a)&&!isNaN(o)&&a===o?a===0&&!s?null:(a=Math.floor(a*d),a+=s?d:-d,String(a/d)):null}textReplace(p,s){return this.valueSetsReplace(this._defaultValueSet,p,s)}valueSetsReplace(p,s,d){let a=null;for(let o=0,f=p.length;a===null&&o<f;o++)a=this.valueSetReplace(p[o],s,d);return a}valueSetReplace(p,s,d){let a=p.indexOf(s);return a>=0?(a+=d?1:-1,a<0?a=p.length-1:a%=p.length,p[a]):null}}t.BasicInplaceReplace=E,E.INSTANCE=new E}),$(z[30],V([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var E;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(E=t.AccessibilitySupport||(t.AccessibilitySupport={}));var M;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(M=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var p;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(p=t.CompletionItemKind||(t.CompletionItemKind={}));var s;(function(e){e[e.Deprecated=1]="Deprecated"})(s=t.CompletionItemTag||(t.CompletionItemTag={}));var d;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var a;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(a=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var o;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(o=t.CursorChangeReason||(t.CursorChangeReason={}));var f;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(f=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var S;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(S=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var c;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(c=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var h;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.bracketPairColorization=12]="bracketPairColorization",e[e.guides=13]="guides",e[e.codeLens=14]="codeLens",e[e.codeLensFontFamily=15]="codeLensFontFamily",e[e.codeLensFontSize=16]="codeLensFontSize",e[e.colorDecorators=17]="colorDecorators",e[e.columnSelection=18]="columnSelection",e[e.comments=19]="comments",e[e.contextmenu=20]="contextmenu",e[e.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",e[e.cursorBlinking=22]="cursorBlinking",e[e.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",e[e.cursorStyle=24]="cursorStyle",e[e.cursorSurroundingLines=25]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",e[e.cursorWidth=27]="cursorWidth",e[e.disableLayerHinting=28]="disableLayerHinting",e[e.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",e[e.domReadOnly=30]="domReadOnly",e[e.dragAndDrop=31]="dragAndDrop",e[e.emptySelectionClipboard=32]="emptySelectionClipboard",e[e.extraEditorClassName=33]="extraEditorClassName",e[e.fastScrollSensitivity=34]="fastScrollSensitivity",e[e.find=35]="find",e[e.fixedOverflowWidgets=36]="fixedOverflowWidgets",e[e.folding=37]="folding",e[e.foldingStrategy=38]="foldingStrategy",e[e.foldingHighlight=39]="foldingHighlight",e[e.foldingImportsByDefault=40]="foldingImportsByDefault",e[e.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=42]="fontFamily",e[e.fontInfo=43]="fontInfo",e[e.fontLigatures=44]="fontLigatures",e[e.fontSize=45]="fontSize",e[e.fontWeight=46]="fontWeight",e[e.formatOnPaste=47]="formatOnPaste",e[e.formatOnType=48]="formatOnType",e[e.glyphMargin=49]="glyphMargin",e[e.gotoLocation=50]="gotoLocation",e[e.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",e[e.hover=52]="hover",e[e.inDiffEditor=53]="inDiffEditor",e[e.inlineSuggest=54]="inlineSuggest",e[e.letterSpacing=55]="letterSpacing",e[e.lightbulb=56]="lightbulb",e[e.lineDecorationsWidth=57]="lineDecorationsWidth",e[e.lineHeight=58]="lineHeight",e[e.lineNumbers=59]="lineNumbers",e[e.lineNumbersMinChars=60]="lineNumbersMinChars",e[e.linkedEditing=61]="linkedEditing",e[e.links=62]="links",e[e.matchBrackets=63]="matchBrackets",e[e.minimap=64]="minimap",e[e.mouseStyle=65]="mouseStyle",e[e.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=67]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",e[e.multiCursorModifier=69]="multiCursorModifier",e[e.multiCursorPaste=70]="multiCursorPaste",e[e.occurrencesHighlight=71]="occurrencesHighlight",e[e.overviewRulerBorder=72]="overviewRulerBorder",e[e.overviewRulerLanes=73]="overviewRulerLanes",e[e.padding=74]="padding",e[e.parameterHints=75]="parameterHints",e[e.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",e[e.quickSuggestions=78]="quickSuggestions",e[e.quickSuggestionsDelay=79]="quickSuggestionsDelay",e[e.readOnly=80]="readOnly",e[e.renameOnType=81]="renameOnType",e[e.renderControlCharacters=82]="renderControlCharacters",e[e.renderFinalNewline=83]="renderFinalNewline",e[e.renderLineHighlight=84]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=86]="renderValidationDecorations",e[e.renderWhitespace=87]="renderWhitespace",e[e.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",e[e.roundedSelection=89]="roundedSelection",e[e.rulers=90]="rulers",e[e.scrollbar=91]="scrollbar",e[e.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=93]="scrollBeyondLastLine",e[e.scrollPredominantAxis=94]="scrollPredominantAxis",e[e.selectionClipboard=95]="selectionClipboard",e[e.selectionHighlight=96]="selectionHighlight",e[e.selectOnLineNumbers=97]="selectOnLineNumbers",e[e.showFoldingControls=98]="showFoldingControls",e[e.showUnused=99]="showUnused",e[e.snippetSuggestions=100]="snippetSuggestions",e[e.smartSelect=101]="smartSelect",e[e.smoothScrolling=102]="smoothScrolling",e[e.stickyTabStops=103]="stickyTabStops",e[e.stopRenderingLineAfter=104]="stopRenderingLineAfter",e[e.suggest=105]="suggest",e[e.suggestFontSize=106]="suggestFontSize",e[e.suggestLineHeight=107]="suggestLineHeight",e[e.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",e[e.suggestSelection=109]="suggestSelection",e[e.tabCompletion=110]="tabCompletion",e[e.tabIndex=111]="tabIndex",e[e.unusualLineTerminators=112]="unusualLineTerminators",e[e.useShadowDOM=113]="useShadowDOM",e[e.useTabStops=114]="useTabStops",e[e.wordSeparators=115]="wordSeparators",e[e.wordWrap=116]="wordWrap",e[e.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=119]="wordWrapColumn",e[e.wordWrapOverride1=120]="wordWrapOverride1",e[e.wordWrapOverride2=121]="wordWrapOverride2",e[e.wrappingIndent=122]="wrappingIndent",e[e.wrappingStrategy=123]="wrappingStrategy",e[e.showDeprecated=124]="showDeprecated",e[e.inlayHints=125]="inlayHints",e[e.editorClassName=126]="editorClassName",e[e.pixelRatio=127]="pixelRatio",e[e.tabFocusMode=128]="tabFocusMode",e[e.layoutInfo=129]="layoutInfo",e[e.wrappingInfo=130]="wrappingInfo"})(h=t.EditorOption||(t.EditorOption={}));var m;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(m=t.EndOfLinePreference||(t.EndOfLinePreference={}));var v;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(v=t.EndOfLineSequence||(t.EndOfLineSequence={}));var i;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(i=t.IndentAction||(t.IndentAction={}));var u;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(u=t.InlayHintKind||(t.InlayHintKind={}));var _;(function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"})(_=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(N=t.KeyCode||(t.KeyCode={}));var n;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(n=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var l;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(l=t.MinimapPosition||(t.MinimapPosition={}));var g;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(g=t.MouseTargetType||(t.MouseTargetType={}));var C;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(C=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var b;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(b=t.OverviewRulerLane||(t.OverviewRulerLane={}));var L;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(L=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var w;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(w=t.RenderMinimap||(t.RenderMinimap={}));var y;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(y=t.ScrollType||(t.ScrollType={}));var P;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(P=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var U;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(U=t.SelectionDirection||(t.SelectionDirection={}));var R;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(R=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var W;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(W=t.SymbolKind||(t.SymbolKind={}));var Y;(function(e){e[e.Deprecated=1]="Deprecated"})(Y=t.SymbolTag||(t.SymbolTag={}));var k;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(k=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var F;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(F=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var B;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(B=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var H;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(H=t.WrappingIndent||(t.WrappingIndent={}))}),$(z[31],V([0,1,21,9,17,13,3,6,24,25,30]),function(I,t,E,M,p,s,d,a,o,f,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class c{static chord(v,i){return(0,p.KeyChord)(v,i)}}t.KeyMod=c,c.CtrlCmd=2048,c.Shift=1024,c.Alt=512,c.WinCtrl=256;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:M.Emitter,KeyCode:S.KeyCode,KeyMod:c,Position:d.Position,Range:a.Range,Selection:o.Selection,SelectionDirection:S.SelectionDirection,MarkerSeverity:S.MarkerSeverity,MarkerTag:S.MarkerTag,Uri:s.URI,Token:f.Token}}t.createMonacoBaseAPI=h}),$(z[32],V([0,1,12]),function(I,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class M{constructor(d,a){this._prefixSumIndexOfResultBrand=void 0,this.index=d,this.remainder=a}}t.PrefixSumIndexOfResult=M;class p{constructor(d){this.values=d,this.prefixSum=new Uint32Array(d.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(d,a){d=(0,E.toUint32)(d);const o=this.values,f=this.prefixSum,S=a.length;return S===0?!1:(this.values=new Uint32Array(o.length+S),this.values.set(o.subarray(0,d),0),this.values.set(o.subarray(d),d+S),this.values.set(a,d),d-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=d-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(f.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(d,a){return d=(0,E.toUint32)(d),a=(0,E.toUint32)(a),this.values[d]===a?!1:(this.values[d]=a,d-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=d-1),!0)}removeValues(d,a){d=(0,E.toUint32)(d),a=(0,E.toUint32)(a);const o=this.values,f=this.prefixSum;if(d>=o.length)return!1;let S=o.length-d;return a>=S&&(a=S),a===0?!1:(this.values=new Uint32Array(o.length-a),this.values.set(o.subarray(0,d),0),this.values.set(o.subarray(d+a),d),this.prefixSum=new Uint32Array(this.values.length),d-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=d-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(f.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(d){return d<0?0:(d=(0,E.toUint32)(d),this._getPrefixSum(d))}_getPrefixSum(d){if(d<=this.prefixSumValidIndex[0])return this.prefixSum[d];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),d>=this.values.length&&(d=this.values.length-1);for(let o=a;o<=d;o++)this.prefixSum[o]=this.prefixSum[o-1]+this.values[o];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],d),this.prefixSum[d]}getIndexOf(d){d=Math.floor(d),this.getTotalSum();let a=0,o=this.values.length-1,f=0,S=0,c=0;for(;a<=o;)if(f=a+(o-a)/2|0,S=this.prefixSum[f],c=S-this.values[f],d<c)o=f-1;else if(d>=S)a=f+1;else break;return new M(f,d-c)}}t.PrefixSumComputer=p}),$(z[33],V([0,1,5,3,32]),function(I,t,E,M,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class s{constructor(a,o,f,S){this._uri=a,this._lines=o,this._eol=f,this._versionId=S,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(a){a.eol&&a.eol!==this._eol&&(this._eol=a.eol,this._lineStarts=null);const o=a.changes;for(const f of o)this._acceptDeleteRange(f.range),this._acceptInsertText(new M.Position(f.range.startLineNumber,f.range.startColumn),f.text);this._versionId=a.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const a=this._eol.length,o=this._lines.length,f=new Uint32Array(o);for(let S=0;S<o;S++)f[S]=this._lines[S].length+a;this._lineStarts=new p.PrefixSumComputer(f)}}_setLineText(a,o){this._lines[a]=o,this._lineStarts&&this._lineStarts.changeValue(a,this._lines[a].length+this._eol.length)}_acceptDeleteRange(a){if(a.startLineNumber===a.endLineNumber){if(a.startColumn===a.endColumn)return;this._setLineText(a.startLineNumber-1,this._lines[a.startLineNumber-1].substring(0,a.startColumn-1)+this._lines[a.startLineNumber-1].substring(a.endColumn-1));return}this._setLineText(a.startLineNumber-1,this._lines[a.startLineNumber-1].substring(0,a.startColumn-1)+this._lines[a.endLineNumber-1].substring(a.endColumn-1)),this._lines.splice(a.startLineNumber,a.endLineNumber-a.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(a.startLineNumber,a.endLineNumber-a.startLineNumber)}_acceptInsertText(a,o){if(o.length===0)return;let f=(0,E.splitLines)(o);if(f.length===1){this._setLineText(a.lineNumber-1,this._lines[a.lineNumber-1].substring(0,a.column-1)+f[0]+this._lines[a.lineNumber-1].substring(a.column-1));return}f[f.length-1]+=this._lines[a.lineNumber-1].substring(a.column-1),this._setLineText(a.lineNumber-1,this._lines[a.lineNumber-1].substring(0,a.column-1)+f[0]);let S=new Uint32Array(f.length-1);for(let c=1;c<f.length;c++)this._lines.splice(a.lineNumber+c-1,0,f[c]),S[c-1]=f[c].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(a.lineNumber,S)}}t.MirrorTextModel=s});var ne=this&&this.__awaiter||function(I,t,E,M){function p(s){return s instanceof E?s:new E(function(d){d(s)})}return new(E||(E=Promise))(function(s,d){function a(S){try{f(M.next(S))}catch(c){d(c)}}function o(S){try{f(M.throw(S))}catch(c){d(c)}}function f(S){S.done?s(S.value):p(S.value).then(a,o)}f((M=M.apply(I,t||[])).next())})};$(z[35],V([0,1,10,2,13,3,6,26,33,27,28,29,31,11,8]),function(I,t,E,M,p,s,d,a,o,f,S,c,h,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=t.MirrorModel=void 0;class i extends o.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(n){return this._lines[n-1]}getWordAtPosition(n,r){let l=(0,f.getWordAtText)(n.column,(0,f.ensureValidWordDefinition)(r),this._lines[n.lineNumber-1],0);return l?new d.Range(n.lineNumber,l.startColumn,n.lineNumber,l.endColumn):null}words(n){const r=this._lines,l=this._wordenize.bind(this);let g=0,C="",b=0,L=[];return{*[Symbol.iterator](){for(;;)if(b<L.length){const w=C.substring(L[b].start,L[b].end);b+=1,yield w}else if(g<r.length)C=r[g],L=l(C,n),b=0,g+=1;else break}}}getLineWords(n,r){let l=this._lines[n-1],g=this._wordenize(l,r),C=[];for(const b of g)C.push({word:l.substring(b.start,b.end),startColumn:b.start+1,endColumn:b.end+1});return C}_wordenize(n,r){const l=[];let g;for(r.lastIndex=0;(g=r.exec(n))&&g[0].length!==0;)l.push({start:g.index,end:g.index+g[0].length});return l}getValueInRange(n){if(n=this._validateRange(n),n.startLineNumber===n.endLineNumber)return this._lines[n.startLineNumber-1].substring(n.startColumn-1,n.endColumn-1);let r=this._eol,l=n.startLineNumber-1,g=n.endLineNumber-1,C=[];C.push(this._lines[l].substring(n.startColumn-1));for(let b=l+1;b<g;b++)C.push(this._lines[b]);return C.push(this._lines[g].substring(0,n.endColumn-1)),C.join(r)}offsetAt(n){return n=this._validatePosition(n),this._ensureLineStarts(),this._lineStarts.getPrefixSum(n.lineNumber-2)+(n.column-1)}positionAt(n){n=Math.floor(n),n=Math.max(0,n),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(n),l=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,l)}}_validateRange(n){const r=this._validatePosition({lineNumber:n.startLineNumber,column:n.startColumn}),l=this._validatePosition({lineNumber:n.endLineNumber,column:n.endColumn});return r.lineNumber!==n.startLineNumber||r.column!==n.startColumn||l.lineNumber!==n.endLineNumber||l.column!==n.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:l.lineNumber,endColumn:l.column}:n}_validatePosition(n){if(!s.Position.isIPosition(n))throw new Error("bad position");let{lineNumber:r,column:l}=n,g=!1;if(r<1)r=1,l=1,g=!0;else if(r>this._lines.length)r=this._lines.length,l=this._lines[r-1].length+1,g=!0;else{let C=this._lines[r-1].length+1;l<1?(l=1,g=!0):l>C&&(l=C,g=!0)}return g?{lineNumber:r,column:l}:n}}t.MirrorModel=i;class u{constructor(n,r){this._host=n,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(n){return this._models[n]}_getModels(){let n=[];return Object.keys(this._models).forEach(r=>n.push(this._models[r])),n}acceptNewModel(n){this._models[n.url]=new i(p.URI.parse(n.url),n.lines,n.EOL,n.versionId)}acceptModelChanged(n,r){if(!this._models[n])return;this._models[n].onEvents(r)}acceptRemovedModel(n){!this._models[n]||delete this._models[n]}computeDiff(n,r,l,g){return ne(this,void 0,void 0,function*(){const C=this._getModel(n),b=this._getModel(r);if(!C||!b)return null;const L=C.getLinesContent(),w=b.getLinesContent(),P=new a.DiffComputer(L,w,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:l,shouldMakePrettyDiff:!0,maxComputationTime:g}).computeDiff(),U=P.changes.length>0?!1:this._modelsAreIdentical(C,b);return{quitEarly:P.quitEarly,identical:U,changes:P.changes}})}_modelsAreIdentical(n,r){const l=n.getLineCount(),g=r.getLineCount();if(l!==g)return!1;for(let C=1;C<=l;C++){const b=n.getLineContent(C),L=r.getLineContent(C);if(b!==L)return!1}return!0}computeMoreMinimalEdits(n,r){return ne(this,void 0,void 0,function*(){const l=this._getModel(n);if(!l)return r;const g=[];let C;r=r.slice(0).sort((b,L)=>{if(b.range&&L.range)return d.Range.compareRangesUsingStarts(b.range,L.range);let w=b.range?0:1,y=L.range?0:1;return w-y});for(let{range:b,text:L,eol:w}of r){if(typeof w=="number"&&(C=w),d.Range.isEmpty(b)&&!L)continue;const y=l.getValueInRange(b);if(L=L.replace(/\r\n|\n|\r/g,l.eol),y===L)continue;if(Math.max(L.length,y.length)>u._diffLimit){g.push({range:b,text:L});continue}const P=(0,E.stringDiff)(y,L,!1),U=l.offsetAt(d.Range.lift(b).getStartPosition());for(const R of P){const W=l.positionAt(U+R.originalStart),Y=l.positionAt(U+R.originalStart+R.originalLength),k={text:L.substr(R.modifiedStart,R.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:Y.lineNumber,endColumn:Y.column}};l.getValueInRange(k.range)!==k.text&&g.push(k)}}return typeof C=="number"&&g.push({eol:C,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),g})}computeLinks(n){return ne(this,void 0,void 0,function*(){let r=this._getModel(n);return r?(0,S.computeLinks)(r):null})}textualSuggest(n,r,l,g){return ne(this,void 0,void 0,function*(){const C=new v.StopWatch(!0),b=new RegExp(l,g),L=new Set;e:for(let w of n){const y=this._getModel(w);if(!!y){for(let P of y.words(b))if(!(P===r||!isNaN(Number(P)))&&(L.add(P),L.size>u._suggestionsLimit))break e}}return{words:Array.from(L),duration:C.elapsed()}})}computeWordRanges(n,r,l,g){return ne(this,void 0,void 0,function*(){let C=this._getModel(n);if(!C)return Object.create(null);const b=new RegExp(l,g),L=Object.create(null);for(let w=r.startLineNumber;w<r.endLineNumber;w++){let y=C.getLineWords(w,b);for(const P of y){if(!isNaN(Number(P.word)))continue;let U=L[P.word];U||(U=[],L[P.word]=U),U.push({startLineNumber:w,startColumn:P.startColumn,endLineNumber:w,endColumn:P.endColumn})}}return L})}navigateValueSet(n,r,l,g,C){return ne(this,void 0,void 0,function*(){let b=this._getModel(n);if(!b)return null;let L=new RegExp(g,C);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let w=b.getValueInRange(r),y=b.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},L);if(!y)return null;let P=b.getValueInRange(y);return c.BasicInplaceReplace.INSTANCE.navigateValueSet(r,w,y,P,l)})}loadForeignModule(n,r,l){const g=(L,w)=>this._host.fhr(L,w);let b={host:m.createProxyObject(l,g),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(b,r),Promise.resolve(m.getAllMethodNames(this._foreignModule))):new Promise((L,w)=>{I([n],y=>{this._foreignModule=y.create(b,r),L(m.getAllMethodNames(this._foreignModule))},w)})}fmr(n,r){if(!this._foreignModule||typeof this._foreignModule[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this._foreignModule[n].apply(this._foreignModule,r))}catch(l){return Promise.reject(l)}}}t.EditorSimpleWorker=u,u._diffLimit=1e5,u._suggestionsLimit=1e4;function _(N){return new u(N,null)}t.create=_,typeof importScripts=="function"&&(M.globals.monaco=(0,h.createMonacoBaseAPI)())}),function(){var I,t;const E=self.MonacoEnvironment,M=E&&E.baseUrl?E.baseUrl:"../../../",p=typeof((I=self.trustedTypes)===null||I===void 0?void 0:I.createPolicy)=="function"?(t=self.trustedTypes)===null||t===void 0?void 0:t.createPolicy("amdLoader",{createScriptURL:S=>S,createScript:(S,...c)=>{const h=c.slice(0,-1).join(","),m=c.pop().toString();return`(function anonymous(${h}) {
${m}
})`}}):void 0;function s(){try{return(p?self.eval(p.createScript("","true")):new Function("true")).call(self),!0}catch(S){return!1}}function d(){return new Promise((S,c)=>{if(typeof self.define=="function"&&self.define.amd)return S();const h=M+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&s()){fetch(h).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${h}`,(p?self.eval(p.createScript("",v)):new Function(v)).call(self),S()}).then(void 0,c);return}p?importScripts(p.createScriptURL(h)):importScripts(h),S()})}const a=function(S){d().then(()=>{require.config({baseUrl:M,catchError:!0,trustedTypesPolicy:p}),require([S],function(c){setTimeout(function(){let h=c.create((m,v)=>{self.postMessage(m,v)},null);for(self.onmessage=m=>h.onmessage(m.data);f.length>0;)self.onmessage(f.shift())},0)})})};let o=!0,f=[];self.onmessage=S=>{if(!o){f.push(S);return}o=!1,a(S.data)}}()}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map